#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc CATMathDialog {} {
    global ed
    global cat

    set w {.catjoin}

    set ed(ok) 0
    set ed(status) {}

    DialogCreate $w [msgcat::mc {Catalog Join}]

    frame $w.options -relief ridge -bd 1
    frame $w.status -relief ridge -bd 1
    frame $w.buttons -relief ridge -bd 1
    pack $w.options $w.status $w.buttons -ipadx 4 -ipady 4 -fill x -expand true

    foreach cc $cat(cats) {
	global $cc
	upvar #0 $cc var

	set ed($cc) 1
	checkbutton $w.options.$cc -text $var(title) -variable ed($cc)
	grid $w.options.$cc -padx 4 -pady 1 -sticky w
    }

    label $w.status.title -text [msgcat::mc {Status}]
    label $w.status.item -textvariable ed(status)
    pack $w.status.title $w.status.item -side left -anchor w -pady 4

    button $w.buttons.ok -text [msgcat::mc {OK}] \
	-default active -command {set ed(ok) 1}
    button $w.buttons.cancel -text [msgcat::mc {Cancel}] \
	-command {set ed(ok) 0}

    pack $w.buttons.ok $w.buttons.cancel -side left -padx 10 -expand true

    bind $w <Return> {set ed(ok) 1}
    bind $w <Alt-o> "tkButtonInvoke $w.buttons.ok"
    bind $w <Alt-c> "tkButtonInvoke $w.buttons.cancel"

    DialogCenter $w 
    DialogWait $w ed(ok)
    DialogDismiss $w

    if {$ed(ok)} {
	foreach cc $cat(cats) {
	    if {$ed($cc)} {
		lappend ed(join) $cc
	    }
	}
	CATMathFrame $ed(join)
    }
}

proc CATMathFrame {cats} {
    global cat

    if {[llength $cats] < 2} {
	return
    }

    incr cat(id)
    set varname "catoth$cat(id)"
    global $varname
    upvar #0 $varname var
    set var(catdb) ${varname}catdb
    global $var(catdb)

    set cvarname [lindex $cats 0]
    global $cvarname
    upvar #0 $cvarname cvar
    global $cvar(catdb)
    array set foo [array get $cvar(catdb)]

    for {set ii 1} {$ii<[llength $cats]} {incr ii} {
	set cvarname [lindex $cats $ii]
	global $cvarname
	upvar #0 $cvarname cvar

	CATMath foo $cvar(catdb) bar
	array set bar [array get foo]
	unset bar
    }

    array set $var(catdb) [array get foo]
    unset foo

    CATDialog $varname {} {} Join db
}

proc CATMath {t1 t2 t0} {
    global $t0
    global $t1
    global $t2

    starbase_writefp $t1 stdout
    puts "CATMath $t1 $t2 $t0"

    array set $t0 [array get t2]
}
