#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc CircleDialog {frame id} {
    global marker

    set w ".marker$id"

    # see if we already have a header window visible
    if [winfo exists $w] {
	raise $w
	return
    }

    # variables
    set marker($frame,$id,dcoord) $marker(dialog,dist,system)
    set marker($frame,$id,dlabel) $marker(dialog,dist,system)
    set marker($frame,$id,dformat) $marker(dialog,dist,format)

    # base
    MarkerBaseCenterDialog $frame $id 375 125

    # menus
    MarkerBaseDistMenu $frame $id radius Radius CircleDistCB dcoord dformat

    # init
    CircleDistCB $frame $id

    # callbacks
    $frame marker $id callback move CircleEditCB $frame
    $frame marker $id callback edit CircleEditCB $frame

    # Radius
    label $w.ref.f.radiusTitle -text [msgcat::mc {Radius}]
    entry $w.ref.f.radius -textvariable marker($frame,$id,radius) -width 13 
    label $w.ref.f.radiusformat -textvariable marker($frame,$id,dlabel) -padx 4
    grid $w.ref.f.radiusTitle $w.ref.f.radius x $w.ref.f.radiusformat \
	-padx 4 -sticky w
}

# actions

proc CircleClose {frame id} {
    $frame marker $id delete callback move CircleEditCB
    $frame marker $id delete callback edit CircleEditCB
    MarkerBaseCenterClose $frame $id
}

proc CircleApply {frame id} {
    global marker

    $frame marker $id circle radius $marker($frame,$id,radius) \
	$marker($frame,$id,dcoord) $marker($frame,$id,dformat)

    MarkerBaseCenterApply $frame $id
}

# callbacks

proc CircleCoordCB {frame id} {
    global debug
    if {$debug(tcl,marker)} {
	puts "CircleCoordCB"
    }
    MarkerBaseCoordCB $frame $id
    MarkerBaseCenterMoveCB $frame $id
}

proc CircleEditCB {frame id} {
    global marker
    global debug
    if {$debug(tcl,marker)} {
	puts "CircleEditCB"
    }

    set marker($frame,$id,radius) \
	[$frame get marker $id circle radius \
	     $marker($frame,$id,dcoord) $marker($frame,$id,dformat)]
}

proc CircleDistCB {frame id} {
    global debug
    if {$debug(tcl,marker)} {
	puts "CircleDistCB"
    }
    MarkerBaseDistCB $frame $id
    CircleEditCB $frame $id
}
