#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc PandaDialog {frame id} {
    global marker

    set w ".marker$id"

    # see if we already have a header window visible
    if [winfo exists $w] {
	raise $w
	return
    }

    # base panda dialog
    MarkerBasePandaDialog $frame $id 275 150

    # Radius
    label $w.ref.left.bottom.f.innerTitle -text [msgcat::mc {Inner}]
    label $w.ref.left.bottom.f.outerTitle -text [msgcat::mc {Outer}]
    label $w.ref.left.bottom.f.radiusTitle -text [msgcat::mc {Radius}]
    entry $w.ref.left.bottom.f.inner -textvariable marker($frame,$id,inner) \
	-width 13
    entry $w.ref.left.bottom.f.outer -textvariable marker($frame,$id,outer) \
	-width 13
    label $w.ref.left.bottom.f.radiusformat \
	-textvariable marker($frame,$id,dlabel) -padx 4
    label $w.ref.left.bottom.f.annuliTitle -text [msgcat::mc {Annuli}]
    entry $w.ref.left.bottom.f.annuli -textvariable marker($frame,$id,annuli) \
	-width 13

    grid x $w.ref.left.bottom.f.innerTitle $w.ref.left.bottom.f.outerTitle  \
	-padx 4 -sticky w
    grid $w.ref.left.bottom.f.radiusTitle $w.ref.left.bottom.f.inner \
	$w.ref.left.bottom.f.outer $w.ref.left.bottom.f.radiusformat \
	-padx 4 -sticky w
    grid $w.ref.left.bottom.f.annuliTitle $w.ref.left.bottom.f.annuli \
	-padx 4 -sticky w

    # init - do this last
    PandaDistCB $frame $id
}

# actions

proc PandaClose {frame id} {
    MarkerBasePandaClose $frame $id
}

proc PandaApply {frame id} {
    MarkerBasePandaApply $frame $id
}

proc PandaGenerate {frame id} {
    MarkerBaseAnnulusGenerateCircle $frame $id
    MarkerBasePandaGenerateAngles $frame $id
}

# callbacks

proc PandaCoordCB {frame id} {
    global debug
    if {$debug(tcl,marker)} {
	puts "PandaCoordCB"
    }
    MarkerBasePandaCoordCB $frame $id
}

proc PandaEditCB {frame id} {
    global marker
    global debug
    if {$debug(tcl,marker)} {
	puts "PandaEditCB"
    }

    set t \
	[$frame get marker $id panda radius \
	     $marker($frame,$id,dcoord) $marker($frame,$id,dformat)]

    set last [expr [llength $t]-1]
    set marker($frame,$id,inner) [lindex $t 0]
    set marker($frame,$id,outer) [lindex $t $last]
    set marker($frame,$id,annuli) $last

    $marker($frame,$id,annulitxt) delete 1.0 end
    $marker($frame,$id,annulitxt) insert end "$t"

    set a [$frame get marker $id panda angle \
	       $marker($frame,$id,system) $marker($frame,$id,sky)]

    set last [expr [llength $a]-1]
    set marker($frame,$id,ang1) [lindex $a 0]
    set marker($frame,$id,ang2) [lindex $a $last]
    set marker($frame,$id,angnum) $last

    $marker($frame,$id,angtxt) delete 1.0 end
    $marker($frame,$id,angtxt) insert end "$a"
}

proc PandaDistCB {frame id} {
    global debug
    if {$debug(tcl,marker)} {
	puts "PandaDistCB"
    }
    MarkerBasePandaDistCB $frame $id
}
