#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc EllipseAnnulusDialog {frame id} {
    global marker

    set w ".marker$id"

    # see if we already have a header window visible
    if [winfo exists $w] {
	raise $w
	return
    }

    # base
    MarkerBaseAnnulusRectDialog $frame $id 275 150 radius Major Minor
}

# actions

proc EllipseAnnulusClose {frame id} {
    MarkerBaseAnnulusRectClose $frame $id
}

proc EllipseAnnulusApply {frame id} {
    MarkerBaseAnnulusRectApply $frame $id
}

proc EllipseAnnulusGenerate {frame id} {
    MarkerBaseAnnulusGenerateEllipse $frame $id
}

# callbacks

proc EllipseAnnulusCoordCB {frame id} {
    global debug
    if {$debug(tcl,marker)} {
	puts "EllipseAnnulusCoordCB"
    }
    MarkerBaseAnnulusRectCoordCB $frame $id
}

proc EllipseAnnulusEditCB {frame id} {
    global debug
    if {$debug(tcl,marker)} {
	puts "EllipseAnnulusEditCB"
    }
    MarkerBaseAnnulusRectEditCB $frame $id
}

proc EllipseAnnulusDistCB {frame id} {
    global debug
    if {$debug(tcl,marker)} {
	puts "EllipseAnnulusDistCB"
    }
    MarkerBaseAnnulusRectDistCB $frame $id
}

