#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc EpandaDialog {frame id} {
    global marker

    set w ".marker$id"

    # see if we already have a header window visible
    if [winfo exists $w] {
	raise $w
	return
    }

    # base panda rect dialog
    MarkerBasePandaRectDialog $frame $id 275 150
}

# actions

proc EpandaClose {frame id} {
    MarkerBasePandaRectClose $frame $id
}

proc EpandaApply {frame id} {
    MarkerBasePandaRectApply $frame $id
}

proc EpandaGenerate {frame id} {
    MarkerBaseAnnulusGenerateEllipse $frame $id
    MarkerBasePandaGenerateAngles $frame $id
}

# callbacks

proc EpandaCoordCB {frame id} {
    global debug
    if {$debug(tcl,marker)} {
	puts "EpandaCoordCB"
    }
    MarkerBasePandaRectCoordCB $frame $id
}

proc EpandaEditCB {frame id} {
    global debug
    if {$debug(tcl,marker)} {
	puts "EpandaEditCB"
    }
    MarkerBasePandaRectEditCB $frame $id
}

proc EpandaDistCB {frame id} {
    global debug
    if {$debug(tcl,marker)} {
	puts "EpandaDistCB"
    }
    MarkerBasePandaDistCB $frame $id
}

