#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc AnalysisMenu {} {
    global ds9

    # WARNING: this is a variable length menu. 
    # Be sure to update ds9(menu,size,analysis)
    menu $ds9(mb).analysis
    $ds9(mb).analysis add command -label "[msgcat::mc {Pixel Table}]..." \
	-command PixelTableDialog 
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton -label [msgcat::mc {Mask}] \
	-variable mask(view) -command MaskUpdate
    $ds9(mb).analysis add cascade -label [msgcat::mc {Mask Parameters}] \
	-menu $ds9(mb).analysis.mask
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton -label [msgcat::mc {Contours}] \
	-variable contour(view) -command ContourUpdate
    $ds9(mb).analysis add command \
	-label "[msgcat::mc {Contour Parameters}]..."\
	-command ContourDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton -label [msgcat::mc {Coordinate Grid}] \
	-variable grid(view) -command GridUpdate
    $ds9(mb).analysis add command \
	-label "[msgcat::mc {Coordinate Grid Parameters}]..." \
	-command GridDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton -label [msgcat::mc {Smooth}] \
	-variable smooth(view) -command SmoothUpdate
    $ds9(mb).analysis add command \
	-label "[msgcat::mc {Smooth Parameters}]..." \
	-command SmoothDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add command \
	-label "[msgcat::mc {Name Resolution}]..." \
	-command NRESDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add cascade -label [msgcat::mc {Image Servers}] \
	-menu $ds9(mb).analysis.image
    $ds9(mb).analysis add cascade -label [msgcat::mc {Archives}] \
	-menu $ds9(mb).analysis.arch
    $ds9(mb).analysis add cascade -label [msgcat::mc {Catalogs}] \
	-menu $ds9(mb).analysis.cat
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add command \
	-label "[msgcat::mc {Virtual Observatory}]..."\
	-command "VODialog 0"
    $ds9(mb).analysis add command -label "[msgcat::mc {Plot Tool}]..." \
	-command AnalysisPlotTool
    $ds9(mb).analysis add command -label "[msgcat::mc {Web Browser}]..." \
	-command {HV web Web {} 2 {}}
    $ds9(mb).analysis add command -label "[msgcat::mc {Catalog Tool}]..." \
	-command CATOther
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton \
	-label [msgcat::mc {Analysis Command Log}] \
	-variable analysis(log)
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add command \
	-label "[msgcat::mc {Load Analysis Commands}]..." \
	-command LoadAnalysisDialog
    $ds9(mb).analysis add command \
	-label [msgcat::mc {Clear Analysis Commands}] \
	-command ClearAnalysisDialog

    # Mask
    menu $ds9(mb).analysis.mask
    $ds9(mb).analysis.mask add command -label "[msgcat::mc {Open}]..." \
	-command {OpenFits mask}
    $ds9(mb).analysis.mask add cascade -label [msgcat::mc {Open Other}] \
	-menu $ds9(mb).analysis.mask.other
    $ds9(mb).analysis.mask add separator
    $ds9(mb).analysis.mask add command -label [msgcat::mc {Clear}] \
	-command MaskClear
    $ds9(mb).analysis.mask add separator
    $ds9(mb).analysis.mask add cascade -label [msgcat::mc {Color}] \
	-menu $ds9(mb).analysis.mask.color

    # Mask Other
    menu $ds9(mb).analysis.mask.other
    $ds9(mb).analysis.mask.other add command \
	-label "[msgcat::mc {Open Array}]..." \
	-command {OpenArray mask}
    $ds9(mb).analysis.mask.other add separator
    $ds9(mb).analysis.mask.other add command \
	-label "[msgcat::mc {Open Multi Ext as Data Cube}]..." \
	-command {OpenDataCubeFits mask}
    $ds9(mb).analysis.mask.other add separator
    $ds9(mb).analysis.mask.other add command \
	-label "[msgcat::mc {Open Mosaic IRAF}]..." \
	-command {OpenMosaicImageIRAFFits mask}
    $ds9(mb).analysis.mask.other add command \
	-label "[msgcat::mc {Open Mosaic IRAF Segment}]..." \
	-command {OpenMosaicIRAFFits mask}
    $ds9(mb).analysis.mask.other add separator
    $ds9(mb).analysis.mask.other add command \
	-label "[msgcat::mc {Open Mosaic WCS}]..." \
	-command {OpenMosaicImageWCSFits mask}
    $ds9(mb).analysis.mask.other add command \
	-label "[msgcat::mc {Open Mosaic WCS Segment}]..." \
	-command {OpenMosaicWCSFits mask}

    DefaultColorMenu $ds9(mb).analysis.mask.color mask(color) MaskColor

    menu $ds9(mb).analysis.image
    $ds9(mb).analysis.image add command \
	-label {SAO-DSS} -command SAODialog
    $ds9(mb).analysis.image add command \
	-label {ESO-DSS I/II} -command ESODialog
    $ds9(mb).analysis.image add command \
	-label {STSCI-DSS I/II} -command STSCIDialog
    $ds9(mb).analysis.image add command \
	-label {IPAC-2MASS} -command 2MASSDialog
    $ds9(mb).analysis.image add command \
	-label {VLA-FIRST} -command FIRSTDialog
    $ds9(mb).analysis.image add command \
	-label {HEASARC-SkyView} -command SkyViewDialog

    menu $ds9(mb).analysis.cat
    $ds9(mb).analysis.cat add command \
	-label [msgcat::mc {Search for Catalogs}] \
	-command "CATCDSSrchDialog catcdssrch1 0"
    $ds9(mb).analysis.cat add command -label [msgcat::mc {Clear All}] \
	-command CATClearCurrentFrame
    $ds9(mb).analysis.cat add separator
    CATCatalogMenu

    # Analysis Archive Menu
    menu $ds9(mb).analysis.arch
    $ds9(mb).analysis.arch add command -label {NVO DataScope} \
	-command HVArchDataScope
    $ds9(mb).analysis.arch add separator
    $ds9(mb).analysis.arch add cascade -label {Chandra} \
	-menu $ds9(mb).analysis.arch.chandra
    $ds9(mb).analysis.arch add command -label {ROSAT All-Sky (MPE/MPG)} \
	-command HVArchRosat
    $ds9(mb).analysis.arch add command -label {SkyView (NASA/HEASARC)} \
	-command HVArchSkyView
    $ds9(mb).analysis.arch add command -label {W3Browse (NASA/HEASARC)} \
	-command HVArchW3Browse
    $ds9(mb).analysis.arch add separator
    $ds9(mb).analysis.arch add command -label {NVSS (NRAO)} \
	-command HVArchNVSS
    $ds9(mb).analysis.arch add command -label {4MASS (NRAO)} \
	-command HVArch4MASS
    $ds9(mb).analysis.arch add command -label {SIRTF FLS/VLA (NRAO)} \
	-command HVArchSIRTF
    $ds9(mb).analysis.arch add command -label {VLA First (NRAO)} \
	-command HVArchFirst
    $ds9(mb).analysis.arch add separator
    $ds9(mb).analysis.arch add command -label {NED (NASA/IPAC)} \
	-command HVArchNED
    $ds9(mb).analysis.arch add cascade -label {SIMBAD (CDS)} \
	-menu $ds9(mb).analysis.arch.simbad
    $ds9(mb).analysis.arch add cascade -label {ADS (SAO)} \
	-menu $ds9(mb).analysis.arch.ads
    $ds9(mb).analysis.arch add separator
    $ds9(mb).analysis.arch add command -label {SAO TDC (SAO)} \
	-command HVArchSAOTDC

    menu $ds9(mb).analysis.arch.chandra
    $ds9(mb).analysis.arch.chandra add command \
	-label {Chaser (NASA/SAO)} -command HVArchChandraChaser
    $ds9(mb).analysis.arch.chandra add command \
	-label {Fast Image (NASA/SAO)} -command HVArchChandraPop
    $ds9(mb).analysis.arch.chandra add command \
	-label {Public FTP (SAO)} -command HVArchChandraFTP

    menu $ds9(mb).analysis.arch.simbad
    $ds9(mb).analysis.arch.simbad add command -label {SAO} \
	-command HVArchSIMBADSAO
    $ds9(mb).analysis.arch.simbad add command -label {CDS} \
	-command HVArchSIMBADCDS

    menu $ds9(mb).analysis.arch.ads
    $ds9(mb).analysis.arch.ads add command -label {SAO} \
	-command HVArchADSSAO
    $ds9(mb).analysis.arch.ads add command -label {CDS} \
	-command HVArchADSCDS
}

proc UpdateAnalysisMenu {} {
    global ds9
    global current
    global analysis

    global debug
    if {$debug(tcl,update)} {
	puts "UpdateAnalysisMenu"
    }

    if {$current(frame) != {}} {
	$ds9(mb) entryconfig [msgcat::mc {Analysis}] -state normal
	for {set i 0} {$i<$analysis(menu,count)} {incr i} {

	    if {[$current(frame) has fits]} {
		set fn [$current(frame) get fits file name 1]
	    } else {
		set fn {none}
	    }

	    # disable by default
	    $analysis(menu,$i,parent) entryconfig $analysis(menu,$i,item) \
		-state disabled

	    foreach t $analysis(menu,$i,template) {
		if {[regexp ".$t" $fn]} {
		    $analysis(menu,$i,parent) entryconfig \
			$analysis(menu,$i,item) -state normal
		    break
		}
	    }
	}
    } else {
	$ds9(mb) entryconfig [msgcat::mc {Analysis}] -state disabled
    }
}

