#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

# Menus

proc FrameMenu {} {
    global ds9

    menu $ds9(mb).frame
    $ds9(mb).frame add command -label [msgcat::mc {New Frame}] \
	-command CreateFrame
    $ds9(mb).frame add command -label [msgcat::mc {New Frame RGB}] \
	-command CreateRGBFrame
    $ds9(mb).frame add separator
    $ds9(mb).frame add command -label [msgcat::mc {Delete Frame}] \
	-command DeleteCurrentFrame
    $ds9(mb).frame add command -label [msgcat::mc {Delete All Frames}] \
	-command DeleteAllFramesMenu
    $ds9(mb).frame add separator
    $ds9(mb).frame add command -label [msgcat::mc {Clear Frame}] \
	-command ClearCurrentFrame
    $ds9(mb).frame add command -label [msgcat::mc {Reset Frame}] \
	-command ResetCurrentFrame
    $ds9(mb).frame add command -label [msgcat::mc {Refresh Frame}] \
	-command UpdateCurrentFrame
    $ds9(mb).frame add separator
    $ds9(mb).frame add radiobutton -label [msgcat::mc {Single Frame}] \
	-variable ds9(display,user) -value single -command DisplayMode
    $ds9(mb).frame add radiobutton -label [msgcat::mc {Tile Frames}] \
	-variable ds9(display,user) -value tile -command DisplayMode
    $ds9(mb).frame add radiobutton -label [msgcat::mc {Blink Frames}] \
	-variable ds9(display,user) -value blink -command DisplayMode
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label [msgcat::mc {Tile}] \
	-menu $ds9(mb).frame.tile
    $ds9(mb).frame add cascade -label [msgcat::mc {Blink Interval}] \
	-menu $ds9(mb).frame.blink
    $ds9(mb).frame add command -label [msgcat::mc {Set Display Size}] \
	-command DisplayDefaultDialog
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label [msgcat::mc {Match Frames}] \
	-menu $ds9(mb).frame.match
    $ds9(mb).frame add command -label [msgcat::mc {Match Colorbars}] \
	-command MatchColorbars
    $ds9(mb).frame add command -label [msgcat::mc {Match Scales}] \
	-command MatchScales
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label [msgcat::mc {Lock Crosshairs}] \
	-menu $ds9(mb).frame.crosshair
    $ds9(mb).frame add separator
    $ds9(mb).frame add command -label "[msgcat::mc {Data Cube}]..." \
	-command CubeDialog
    $ds9(mb).frame add command -label "[msgcat::mc {RGB}]..." \
	-command RGBDialog
    $ds9(mb).frame add separator
    $ds9(mb).frame add command -label [msgcat::mc {Move First}] \
	-command MoveFirstFrame
    $ds9(mb).frame add command -label [msgcat::mc {Move Back}] \
	-command MovePrevFrame
    $ds9(mb).frame add command -label [msgcat::mc {Move Forward}] \
	-command MoveNextFrame
    $ds9(mb).frame add command -label [msgcat::mc {Move Last}] \
	-command MoveLastFrame
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label [msgcat::mc {Show/Hide Frames}] \
	-menu $ds9(mb).frame.active
    $ds9(mb).frame add separator
    $ds9(mb).frame add command -label [msgcat::mc {First Frame}] \
	-command FirstFrame
    $ds9(mb).frame add command -label [msgcat::mc {Previous Frame}] \
	-command PrevFrame
    $ds9(mb).frame add command -label [msgcat::mc {Next Frame}] \
	-command NextFrame
    $ds9(mb).frame add command -label [msgcat::mc {Last Frame}] \
	-command LastFrame
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label [msgcat::mc {Goto Frame}] \
	-menu $ds9(mb).frame.goto

    menu $ds9(mb).frame.goto

    menu $ds9(mb).frame.active
    $ds9(mb).frame.active add command -label [msgcat::mc {Show All}] \
	-command ActiveFrameAll
    $ds9(mb).frame.active add command -label [msgcat::mc {Hide All}] \
	-command ActiveFrameNone
    $ds9(mb).frame.active add separator

    menu $ds9(mb).frame.match
    $ds9(mb).frame.match add command -label [msgcat::mc {WCS}] \
	-command MatchFramesWCS
    $ds9(mb).frame.match add command -label [msgcat::mc {Image}] \
	-command {MatchFrames image}
    $ds9(mb).frame.match add command -label [msgcat::mc {Physical}] \
	-command {MatchFrames physical}
    $ds9(mb).frame.match add command -label [msgcat::mc {Amplifier}] \
	-command {MatchFrames amplifier}
    $ds9(mb).frame.match add command -label [msgcat::mc {Detector}] \
	-command {MatchFrames detector}

    DefaultCoordMenu1 $ds9(mb).frame.crosshair crosshair(lock) {}
    $ds9(mb).frame.crosshair insert 1 radiobutton \
	-label [msgcat::mc {None}] -variable crosshair(lock) -value none
    $ds9(mb).frame.crosshair insert 2 separator

    menu $ds9(mb).frame.tile
    $ds9(mb).frame.tile add radiobutton -label [msgcat::mc {Grid}] \
	-variable tile(mode) -value grid -command DisplayMode
    $ds9(mb).frame.tile add radiobutton -label [msgcat::mc {Columns}] \
	-variable tile(mode) -value column -command DisplayMode
    $ds9(mb).frame.tile add radiobutton -label [msgcat::mc {Rows}] \
	-variable tile(mode) -value row -command DisplayMode
    $ds9(mb).frame.tile add separator
    $ds9(mb).frame.tile add command \
	-label "[msgcat::mc {Tile Parameters}]..." -command TileDialog

    menu $ds9(mb).frame.blink
    $ds9(mb).frame.blink add radiobutton -label ".125 [msgcat::mc {Seconds}]" \
	-variable blink(interval) -value 125
    $ds9(mb).frame.blink add radiobutton -label ".25 [msgcat::mc {Seconds}]" \
	-variable blink(interval) -value 250
    $ds9(mb).frame.blink add radiobutton -label ".5 [msgcat::mc {Seconds}]" \
	-variable blink(interval) -value 500
    $ds9(mb).frame.blink add radiobutton -label "1 [msgcat::mc {Seconds}]" \
	-variable blink(interval) -value 1000
    $ds9(mb).frame.blink add radiobutton -label "2  [msgcat::mc {Seconds}]" \
	-variable blink(interval) -value 2000
    $ds9(mb).frame.blink add radiobutton -label "4 [msgcat::mc {Seconds}]" \
	-variable blink(interval) -value 4000
    $ds9(mb).frame.blink add radiobutton -label "8 [msgcat::mc {Seconds}]" \
	-variable blink(interval) -value 8000
}

proc PrefsDialogFrame {} {
    global prefs

    set w $prefs(tabs)

    frame $w.frame
    $prefs(tabs) tab configure frame -window $w.frame -fill both

    frame $w.frame.menu -relief ridge -bd 1
    pack $w.frame.menu -side top -fill both -expand true

    # Buttons
    PrefsDialogButtons $w.frame

    # Default Menu
    set f $w.frame.menu.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Default Menu}]
    menubutton $f.frame -relief raised -text [msgcat::mc {Frame}] \
	-menu $f.frame.menu

    grid $f.title $f.frame -padx 4 -sticky w

    set m $f.frame.menu
    menu $m
    $m add cascade -label [msgcat::mc {Tile}] \
	-menu $m.tile
    $m add cascade -label [msgcat::mc {Blink Interval}] \
	-menu $m.blink

    menu $m.tile
    $m.tile add radiobutton -label [msgcat::mc {Grid}] \
	-variable prefs(tile,mode) -value grid
    $m.tile add radiobutton -label [msgcat::mc {Columns}] \
	-variable prefs(tile,mode) -value column
    $m.tile add radiobutton -label [msgcat::mc {Rows}] \
	-variable prefs(tile,mode) -value row

    menu $m.blink
    $m.blink add radiobutton -label ".125 [msgcat::mc {Seconds}]" \
	-variable prefs(blink,interval) -value 125
    $m.blink add radiobutton -label ".25 [msgcat::mc {Seconds}]" \
	-variable prefs(blink,interval) -value 250
    $m.blink add radiobutton -label ".5 [msgcat::mc {Seconds}]" \
	-variable prefs(blink,interval) -value 500
    $m.blink add radiobutton -label "1 [msgcat::mc {Seconds}]" \
	-variable prefs(blink,interval) -value 1000
    $m.blink add radiobutton -label "2  [msgcat::mc {Seconds}]" \
	-variable prefs(blink,interval) -value 2000
    $m.blink add radiobutton -label "4 [msgcat::mc {Seconds}]" \
	-variable prefs(blink,interval) -value 4000
    $m.blink add radiobutton -label "8 [msgcat::mc {Seconds}]" \
	-variable prefs(blink,interval) -value 8000
}

# Buttons

proc ButtonsVarsFrame {} {
    global buttons

    array set buttons {
	frame,new 1
	frame,newrgb 1
	frame,delete 1
	frame,deleteall 0
	frame,clear 1
	frame,reset 0
	frame,refresh 0
	frame,single 1
	frame,tile 1
	frame,blink 1
	frame,size 0
	frame,matchframe 0
	frame,matchcolor 0
	frame,matchscale 0
	frame,cube 0
	frame,rgb 0
	frame,movefirst 0
	frame,moveprev 0
	frame,movenext 0
	frame,movelast 0
	frame,first 1
	frame,prev 1
	frame,next 1
	frame,last 1
    }
}

proc CreateButtonsFrame {} {
    global ds9
    global buttons

    frame $ds9(buttons).frame

    ButtonButton $ds9(buttons).frame.new \
	[string tolower [msgcat::mc {New}]] CreateFrame
    ButtonButton $ds9(buttons).frame.newrgb \
	[string tolower [msgcat::mc {New RGB}]] CreateRGBFrame

    ButtonButton $ds9(buttons).frame.delete \
	[string tolower [msgcat::mc {Delete}]] DeleteCurrentFrame
    ButtonButton $ds9(buttons).frame.deleteall \
	[string tolower [msgcat::mc {Delete All}]] DeleteAllFramesMenu

    ButtonButton $ds9(buttons).frame.clear \
	[string tolower [msgcat::mc {Clear}]] ClearCurrentFrame
    ButtonButton $ds9(buttons).frame.reset \
	[string tolower [msgcat::mc {Reset}]] ResetCurrentFrame
    ButtonButton $ds9(buttons).frame.refresh \
	[string tolower [msgcat::mc {Refresh}]] UpdateCurrentFrame

    RadioButton $ds9(buttons).frame.single \
	[string tolower [msgcat::mc {Single}]] \
	ds9(display,user) single DisplayMode
    RadioButton $ds9(buttons).frame.tile \
	[string tolower [msgcat::mc {Tile}]] \
	ds9(display,user) tile DisplayMode
    RadioButton $ds9(buttons).frame.blink \
	[string tolower [msgcat::mc {Blink}]] \
	ds9(display,user) blink DisplayMode

    ButtonButton $ds9(buttons).frame.size \
	[string tolower [msgcat::mc {Size}]] DisplayDefaultDialog

    ButtonButton $ds9(buttons).frame.matchframe \
	[string tolower [msgcat::mc {Match Frames}]] MatchFramesWCS
    ButtonButton $ds9(buttons).frame.matchcolor \
	[string tolower [msgcat::mc {Match Colorbars}]] MatchColorbars
    ButtonButton $ds9(buttons).frame.matchscale \
	[string tolower [msgcat::mc {Match Scales}]] MatchScales

    ButtonButton $ds9(buttons).frame.cube \
	[string tolower [msgcat::mc {Data Cube}]] CubeDialog
    ButtonButton $ds9(buttons).frame.rgb \
	[string tolower [msgcat::mc {RGB}]] RGBDialog

    ButtonButton $ds9(buttons).frame.movefirst \
	[string tolower [msgcat::mc {Move First}]] MoveFirstFrame
    ButtonButton $ds9(buttons).frame.moveprev \
	[string tolower [msgcat::mc {Move Back}]] MovePrevFrame
    ButtonButton $ds9(buttons).frame.movenext \
	[string tolower [msgcat::mc {Move Forward}]] MoveNextFrame
    ButtonButton $ds9(buttons).frame.movelast \
	[string tolower [msgcat::mc {Move Last}]] MoveLastFrame

    ButtonButton $ds9(buttons).frame.first \
	[string tolower [msgcat::mc {First}]] FirstFrame
    ButtonButton $ds9(buttons).frame.prev \
	[string tolower [msgcat::mc {Previous}]] PrevFrame
    ButtonButton $ds9(buttons).frame.next \
	[string tolower [msgcat::mc {Next}]] NextFrame
    ButtonButton $ds9(buttons).frame.last \
	[string tolower [msgcat::mc {Last}]] LastFrame

    set buttons(frame) "
        $ds9(buttons).frame.new buttons(frame,new)
        $ds9(buttons).frame.newrgb buttons(frame,newrgb)
        $ds9(buttons).frame.delete buttons(frame,delete)
        $ds9(buttons).frame.deleteall buttons(frame,deleteall)
        $ds9(buttons).frame.clear buttons(frame,clear)
        $ds9(buttons).frame.reset buttons(frame,reset)
        $ds9(buttons).frame.refresh buttons(frame,refresh)
        $ds9(buttons).frame.single buttons(frame,single)
        $ds9(buttons).frame.tile buttons(frame,tile)
        $ds9(buttons).frame.blink buttons(frame,blink)
        $ds9(buttons).frame.size buttons(frame,size)
        $ds9(buttons).frame.matchframe buttons(frame,matchframe)
        $ds9(buttons).frame.matchcolor buttons(frame,matchcolor)
        $ds9(buttons).frame.matchscale buttons(frame,matchscale)
        $ds9(buttons).frame.cube buttons(frame,cube)
        $ds9(buttons).frame.rgb buttons(frame,rgb)
        $ds9(buttons).frame.movefirst buttons(frame,movefirst)
        $ds9(buttons).frame.moveprev buttons(frame,moveprev)
        $ds9(buttons).frame.movenext buttons(frame,movenext)
        $ds9(buttons).frame.movelast buttons(frame,movelast)
        $ds9(buttons).frame.first buttons(frame,first)
        $ds9(buttons).frame.prev buttons(frame,prev)
        $ds9(buttons).frame.next buttons(frame,next)
        $ds9(buttons).frame.last buttons(frame,last)
    "
}

proc PrefsDialogButtonbarFrame {f} {
    global buttons

    menubutton $f -relief raised -text [msgcat::mc {Frame}] -menu $f.menu
    
    set m $f.menu
    menu $m
    $m add checkbutton -label [msgcat::mc {New Frame}] \
	-variable buttons(frame,new) -command {UpdateButtons buttons(frame)}
    $m add checkbutton -label [msgcat::mc {New Frame RGB}] \
	-variable buttons(frame,newrgb) -command {UpdateButtons buttons(frame)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Delete Frame}] \
	-variable buttons(frame,delete) -command {UpdateButtons buttons(frame)}
    $m add checkbutton -label [msgcat::mc {Delete All Frames}] \
	-variable buttons(frame,deleteall) -command {UpdateButtons buttons(frame)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Clear Frame}] \
	-variable buttons(frame,clear) -command {UpdateButtons buttons(frame)}
    $m add checkbutton -label [msgcat::mc {Reset Frame}] \
	-variable buttons(frame,reset) -command {UpdateButtons buttons(frame)}
    $m add checkbutton -label [msgcat::mc {Refresh Frame}] \
	-variable buttons(frame,refresh) -command {UpdateButtons buttons(frame)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Single Frame}] \
	-variable buttons(frame,single) -command {UpdateButtons buttons(frame)}
    $m add checkbutton -label [msgcat::mc {Tile Frames}] \
	-variable buttons(frame,tile) -command {UpdateButtons buttons(frame)}
    $m add checkbutton -label [msgcat::mc {Blink Frames}] \
	-variable buttons(frame,blink) -command {UpdateButtons buttons(frame)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Set Display Size}] \
	-variable buttons(frame,size) -command {UpdateButtons buttons(frame)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Match Frames}] \
	-variable buttons(frame,matchframe) -command {UpdateButtons buttons(frame)}
    $m add checkbutton -label [msgcat::mc {Match Colorbars}] \
	-variable buttons(frame,matchcolor) -command {UpdateButtons buttons(frame)}
    $m add checkbutton -label [msgcat::mc {Match Scales}] \
	-variable buttons(frame,matchscale) -command {UpdateButtons buttons(frame)}
    $m add separator
    $m add checkbutton -label "[msgcat::mc {Data Cube}]..." \
	-variable buttons(frame,cube) -command {UpdateButtons buttons(frame)}
    $m add checkbutton -label "[msgcat::mc {RGB}]..." \
	-variable buttons(frame,rgb) -command {UpdateButtons buttons(frame)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Move First}] \
	-variable buttons(frame,movefirst) -command {UpdateButtons buttons(frame)}
    $m add checkbutton -label [msgcat::mc {Move Back}] \
	-variable buttons(frame,moveprev) -command {UpdateButtons buttons(frame)}
    $m add checkbutton -label [msgcat::mc {Move Forward}] \
	-variable buttons(frame,movenext) -command {UpdateButtons buttons(frame)}
    $m add checkbutton -label [msgcat::mc {Move Last}] \
	-variable buttons(frame,movelast) -command {UpdateButtons buttons(frame)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {First Frame}] \
	-variable buttons(frame,first) -command {UpdateButtons buttons(frame)}
    $m add checkbutton -label [msgcat::mc {Previous Frame}] \
	-variable buttons(frame,prev) -command {UpdateButtons buttons(frame)}
    $m add checkbutton -label [msgcat::mc {Next Frame}] \
	-variable buttons(frame,next) -command {UpdateButtons buttons(frame)}
    $m add checkbutton -label [msgcat::mc {Last Frame}] \
	-variable buttons(frame,last) -command {UpdateButtons buttons(frame)}
}

# Support

proc UpdateFrameMenu {} {
    global ds9
    global current
    global rgb

    global debug
    if {$debug(tcl,update)} {
	puts "UpdateFrameMenu"
    }

    switch -- $ds9(visual) {
	pseudocolor {
	    $ds9(mb).frame entryconfig [msgcat::mc {New Frame RGB}] \
		-state disabled
	    $ds9(buttons).frame.newrgb configure -state disabled
	}
	truecolor {
	    $ds9(mb).frame entryconfig [msgcat::mc {New Frame RGB}] \
		-state normal
	    $ds9(buttons).frame.newrgb configure -state normal
	}
    }

    if {$current(frame) != {}} {
	$ds9(mb).frame entryconfig [msgcat::mc {Delete Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Delete All Frames}] \
	    -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Clear Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Reset Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Refresh Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Single Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Tile Frames}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Blink Frames}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Tile}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Blink Interval}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Match Frames}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Match Colorbars}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Match Scales}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Lock Crosshairs}] -state normal
	$ds9(mb).frame entryconfig "[msgcat::mc {Data Cube}]..." -state normal

	if {[$current(frame) get type] == {rgb}} {
	    $ds9(mb).frame entryconfig "[msgcat::mc {RGB}]..." -state normal
	} else {
	    $ds9(mb).frame entryconfig "[msgcat::mc {RGB}]..." -state disabled
	}
	$ds9(mb).frame entryconfig [msgcat::mc {Move First}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Move Back}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Move Forward}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Move Last}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {First Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Previous Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Next Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Last Frame}] -state normal

	$ds9(buttons).frame.delete configure -state normal
	$ds9(buttons).frame.deleteall configure -state normal

	$ds9(buttons).frame.clear configure -state normal
	$ds9(buttons).frame.reset configure -state normal
	$ds9(buttons).frame.refresh configure -state normal

	$ds9(buttons).frame.single configure -state normal
	$ds9(buttons).frame.tile configure -state normal
	$ds9(buttons).frame.blink configure -state normal

	$ds9(buttons).frame.matchframe configure -state normal
	$ds9(buttons).frame.matchcolor configure -state normal
	$ds9(buttons).frame.matchscale configure -state normal

	$ds9(buttons).frame.cube configure -state normal
	if {[$current(frame) get type] == {rgb}} {
	    $ds9(buttons).frame.rgb configure -state normal
	} else {
	    $ds9(buttons).frame.rgb configure -state disabled
	}

	$ds9(buttons).frame.movefirst configure -state normal
	$ds9(buttons).frame.moveprev configure -state normal
	$ds9(buttons).frame.movenext configure -state normal
	$ds9(buttons).frame.movelast configure -state normal

	$ds9(buttons).frame.first configure -state normal
	$ds9(buttons).frame.prev configure -state normal
	$ds9(buttons).frame.next configure -state normal
	$ds9(buttons).frame.last configure -state normal
    } else {
	$ds9(mb).frame entryconfig [msgcat::mc {Delete Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Delete All Frames}] \
	    -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Clear Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Reset Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Refresh Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Single Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Tile Frames}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Blink Frames}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Tile}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Blink Interval}] \
	    -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Match Frames}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Match Colorbars}] \
	    -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Match Scales}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Lock Crosshairs}] \
	    -state disabled
	$ds9(mb).frame entryconfig "[msgcat::mc {Data Cube}]..." \
	    -state disabled
	$ds9(mb).frame entryconfig "[msgcat::mc {RGB}]..." -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Move First}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Move Back}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Move Forward}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Move Last}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {First Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Previous Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Next Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Last Frame}] -state disabled

	$ds9(buttons).frame.delete configure -state disabled
	$ds9(buttons).frame.deleteall configure -state disabled

	$ds9(buttons).frame.clear configure -state disabled
	$ds9(buttons).frame.reset configure -state disabled
	$ds9(buttons).frame.refresh configure -state disabled

	$ds9(buttons).frame.single configure -state disabled
	$ds9(buttons).frame.tile configure -state disabled
	$ds9(buttons).frame.blink configure -state disabled

	$ds9(buttons).frame.matchframe configure -state disabled
	$ds9(buttons).frame.matchcolor configure -state disabled
	$ds9(buttons).frame.matchscale configure -state disabled

	$ds9(buttons).frame.cube configure -state disabled
	$ds9(buttons).frame.rgb configure -state disabled

	$ds9(buttons).frame.movefirst configure -state disabled
	$ds9(buttons).frame.moveprev configure -state disabled
	$ds9(buttons).frame.movenext configure -state disabled
	$ds9(buttons).frame.movelast configure -state disabled

	$ds9(buttons).frame.first configure -state disabled
	$ds9(buttons).frame.prev configure -state disabled
	$ds9(buttons).frame.next configure -state disabled
	$ds9(buttons).frame.last configure -state disabled
    }
}

# Frame Menu Delete
proc UpdateFrameMenuItems {} {
    global ds9

    # Goto Frame Menu
    if {[$ds9(mb).frame.goto index end] >= $ds9(menu,size,frame,goto)} {
	$ds9(mb).frame.goto delete $ds9(menu,size,frame,goto) end
    }

    set cnt $ds9(menu,size,frame,goto)
    foreach f $ds9(frames) {
	set which "[msgcat::mc {Frame}] [string range $f 5 end]"
	$ds9(mb).frame.goto add radiobutton -label $which \
	    -variable ds9(next) -value $f -command GotoFrame

	# wrap if needed
	incr cnt
	if {$cnt>=$ds9(menu,size,wrap)} {
	    set cnt 1
	    $ds9(mb).frame.goto entryconfig $which -columnbreak 1
	}
    }

    # Active Frame Menu
    if {[$ds9(mb).frame.active index end] >= $ds9(menu,size,frame,active)} {
	$ds9(mb).frame.active delete $ds9(menu,size,frame,active) end
    }

    set cnt $ds9(menu,size,frame,active)
    foreach f $ds9(frames) {
	set which "[msgcat::mc {Frame}] [string range $f 5 end]"
	$ds9(mb).frame.active add checkbutton -label $which \
	    -variable active($f) -command UpdateActiveFrames

	# wrap if needed
	incr cnt
	if {$cnt>=$ds9(menu,size,wrap)} {
	    set cnt 1
	    $ds9(mb).frame.active entryconfig $which -columnbreak 1
	}
    }
}

