#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

# Menu

proc HelpMenu {varname} {
    upvar $varname var

    $var add cascade -label [msgcat::mc {Help}] -menu $var.help

    menu $var.help
    $var.help add command -label [msgcat::mc {Reference Manual}]\
	-command HelpRef
    $var.help add command -label [msgcat::mc {Keyboard Shortcuts}] \
	-command HelpKeyboard
    $var.help add separator
    $var.help add command -label [msgcat::mc {FAQ}] \
	-command HelpFAQ
    $var.help add command -label [msgcat::mc {New Features}] \
	-command HelpNew
    $var.help add command -label [msgcat::mc {Known Issues}] \
	-command HelpIssue
    $var.help add command -label [msgcat::mc {Release Notes}] \
	-command HelpRelease
    $var.help add command -label [msgcat::mc {Help Desk}] \
	-command HelpDesk
    $var.help add separator
    $var.help add command -label [msgcat::mc {Acknowledgment}] \
	-command HelpAck
    $var.help add command -label [msgcat::mc {DS9 Home Page}] \
	-command HelpHome
}

# Buttons

proc ButtonsVarsHelp {} {
    global buttons

    array set buttons {
	help,ref 1
	help,keyboard 1
	help,faq 0
	help,new 0
	help,issue 0
	help,release 1
	help,desk 1
	help,ack 1
	help,home 1
    }
}

proc CreateButtonsHelp {} {
    global buttons
    global ds9

    frame $ds9(buttons).help

    ButtonButton $ds9(buttons).help.ref \
	[string tolower [msgcat::mc {Reference}]] HelpRef
    ButtonButton $ds9(buttons).help.keyboard \
	[string tolower [msgcat::mc {Keyboard}]] HelpKeyboard
    ButtonButton $ds9(buttons).help.faq \
	[string tolower [msgcat::mc {FAQ}]] HelpFAQ
    ButtonButton $ds9(buttons).help.new \
	[string tolower [msgcat::mc {New Features}]] HelpNew
    ButtonButton $ds9(buttons).help.issue \
	[string tolower [msgcat::mc {Known Issues}]] HelpIssue
    ButtonButton $ds9(buttons).help.release \
	[string tolower [msgcat::mc {Release}]] HelpRelease
    ButtonButton $ds9(buttons).help.desk \
	[string tolower [msgcat::mc {Help Desk}]] HelpDesk
    ButtonButton $ds9(buttons).help.ack \
	[string tolower [msgcat::mc {Acknowledgment}]] HelpAck
    ButtonButton $ds9(buttons).help.home \
	[string tolower [msgcat::mc {Home}]] HelpHome

    set buttons(help) "
        $ds9(buttons).help.ref buttons(help,ref)
        $ds9(buttons).help.keyboard buttons(help,keyboard)
        $ds9(buttons).help.faq buttons(help,faq)
        $ds9(buttons).help.new buttons(help,new)
        $ds9(buttons).help.issue buttons(help,issue)
        $ds9(buttons).help.release buttons(help,release)
        $ds9(buttons).help.desk buttons(help,desk)
        $ds9(buttons).help.ack buttons(help,ack)
        $ds9(buttons).help.home buttons(help,home)
    "
}

proc PrefsDialogButtonbarHelp {f} {
    global buttons

    menubutton $f -relief raised -text [msgcat::mc {Help}] -menu $f.menu
    
    set m $f.menu
    menu $m
    $m add checkbutton -label [msgcat::mc {Reference Manual}]\
	-variable buttons(help,ref) -command {UpdateButtons buttons(help)}
    $m add checkbutton -label [msgcat::mc {Keyboard Shortcuts}] \
	-variable buttons(help,keyboard) -command {UpdateButtons buttons(help)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {FAQ}] \
	-variable buttons(help,faq) -command {UpdateButtons buttons(help)}
    $m add checkbutton -label [msgcat::mc {New Features}] \
	-variable buttons(help,new) -command {UpdateButtons buttons(help)}
    $m add checkbutton -label [msgcat::mc {Known Issues}] \
	-variable buttons(help,issue) -command {UpdateButtons buttons(help)}
    $m add checkbutton -label [msgcat::mc {Release Notes}] \
	-variable buttons(help,release) -command {UpdateButtons buttons(help)}
    $m add checkbutton -label [msgcat::mc {Help Desk}] \
	-variable buttons(help,desk) -command {UpdateButtons buttons(help)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Acknowledgment}] \
	-variable buttons(help,ack) -command {UpdateButtons buttons(help)}
    $m add checkbutton -label [msgcat::mc {DS9 Home Page}] \
	-variable buttons(help,home) -command {UpdateButtons buttons(help)}
}