#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

# Menus

proc ViewMenu {} {
    global ds9

    menu $ds9(mb).view
    $ds9(mb).view add radiobutton -label [msgcat::mc {Horizontal Layout}] \
	-variable view(layout) -value horizontal  \
	-command {LayoutViewReset; UpdateView}
    $ds9(mb).view add radiobutton -label [msgcat::mc {Vertical Layout}] \
	-variable view(layout) -value vertical  \
	-command {LayoutViewReset; UpdateView}
    $ds9(mb).view add separator
    $ds9(mb).view add checkbutton -label [msgcat::mc {Information Panel}] \
	-variable view(info) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Panner}] \
	-variable view(panner) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Magnifier}] \
	-variable view(magnifier) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Buttons}] \
	-variable view(buttons) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Colorbar}] \
	-variable view(colorbar) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Horizontal Graph}] \
	-variable view(graph,horz) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Vertical Graph}] \
	-variable view(graph,vert) -command UpdateView
    $ds9(mb).view add separator
    $ds9(mb).view add checkbutton -label [msgcat::mc {Filename}] \
	-variable view(info,filename) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Object}] \
	-variable view(info,object) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Min Max}] \
	-variable view(info,minmax) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Low High}] \
	-variable view(info,lowhigh) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Frame Information}] \
	-variable view(info,frame) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {WCS}] \
	-variable view(info,wcs) -command UpdateView
    $ds9(mb).view add cascade -label [msgcat::mc {Multiple WCS}] \
	-menu $ds9(mb).view.mwcs -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Image}] \
	-variable view(info,image) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Physical}] \
	-variable view(info,physical) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Amplifier}] \
	-variable view(info,amplifier) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Detector}] \
	-variable view(info,detector) -command UpdateView
    $ds9(mb).view add separator
    $ds9(mb).view add checkbutton -label [msgcat::mc {Colorbar Numerics}] \
	-variable view(colorbar,numerics) -command UpdateView

    # View Info Panel WCS
    menu $ds9(mb).view.mwcs
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).view.mwcs add checkbutton \
	    -label "[msgcat::mc {WCS}] $l" \
	    -variable "view(info,wcs$l)" \
	    -command UpdateView
    }
}

proc PrefsDialogView {} {
    global prefs
    global ds9

    set w $prefs(tabs)

    frame $w.view
    $prefs(tabs) tab configure view -window $w.view -fill both

    frame $w.view.menu -relief ridge -bd 1
    frame $w.view.misc -relief ridge -bd 1
    frame $w.view.horz -relief ridge -bd 1
    frame $w.view.vert -relief ridge -bd 1
    frame $w.view.box -relief ridge -bd 1
    frame $w.view.panner -relief ridge -bd 1
    frame $w.view.magnifier -relief ridge -bd 1
    pack $w.view.menu $w.view.misc $w.view.horz $w.view.vert \
	$w.view.box $w.view.panner $w.view.magnifier \
	-side top -fill both -expand true

    # Buttons
    PrefsDialogButtons $w.view

    # Default Menu
    set f $w.view.menu.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Default Menu}]
    menubutton $f.view -relief raised -text [msgcat::mc {View}] \
	-menu $f.view.menu

    grid $f.title $f.view -padx 4 -sticky w

    set m $f.view.menu
    menu $m
    $m add radiobutton -label [msgcat::mc {Horizontal Layout}] \
	-variable pview(layout) -value horizontal
    $m add radiobutton -label [msgcat::mc {Vertical Layout}] \
	-variable pview(layout) -value vertical
    $m add separator
    $m add checkbutton -label [msgcat::mc {Information Panel}] \
	-variable pview(info)
    $m add checkbutton -label [msgcat::mc {Panner}] \
	-variable pview(panner)
    $m add checkbutton -label [msgcat::mc {Magnifier}] \
	-variable pview(magnifier)
    $m add checkbutton -label [msgcat::mc {Buttons}] \
	-variable pview(buttons)
    $m add checkbutton -label [msgcat::mc {Colorbar}] \
	-variable pview(colorbar)
    $m add checkbutton -label [msgcat::mc {Horizontal Graph}] \
	-variable pview(graph,horz)
    $m add checkbutton -label [msgcat::mc {Vertical Graph}] \
	-variable pview(graph,vert)
    $m add separator
    $m add checkbutton -label [msgcat::mc {Filename}] \
	-variable pview(info,filename)
    $m add checkbutton -label [msgcat::mc {Object}] \
	-variable pview(info,object)
    $m add checkbutton -label [msgcat::mc {Min Max}] \
	-variable pview(info,minmax)
    $m add checkbutton -label [msgcat::mc {Low High}] \
	-variable pview(info,lowhigh)
    $m add checkbutton -label  [msgcat::mc {Frame Information}]\
	-variable pview(info,frame)
    $m add checkbutton -label [msgcat::mc {WCS}] \
	-variable pview(info,wcs)
    $m add cascade -label [msgcat::mc {Multiple WCS}] -menu $m.wcs
    $m add checkbutton -label [msgcat::mc {Image}] \
	-variable pview(info,image)
    $m add checkbutton -label [msgcat::mc {Physical}] \
	-variable pview(info,physical)
    $m add checkbutton -label [msgcat::mc {Amplifier}] \
	-variable pview(info,amplifier)
    $m add checkbutton -label [msgcat::mc {Detector}] \
	-variable pview(info,detector)
    $m add separator
    $m add checkbutton -label [msgcat::mc {Colorbar Numerics}] \
	-variable pview(colorbar,numerics)

    menu $m.wcs
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$m.wcs add checkbutton -label "[msgcat::mc {WCS}] $l" \
	    -variable "pview(info,wcs$l)"
    }

    # Misc
    set f $w.view.misc.f
    frame $f
    pack $f -anchor w -fill y -expand true

    # --Language
    label $f.tlang -text [msgcat::mc {Language}]
    menubutton $f.lang -relief raised \
	-textvariable ds9(language,name) -menu $f.lang.menu

    set m $f.lang.menu
    menu $m
    $m add radiobutton -label [LanguageToName locale] \
	-variable ds9(language,name) -command "set ds9(language) locale"
    $m add separator
    $m add radiobutton -label [LanguageToName da] \
	-variable ds9(language,name) -command "set ds9(language) da"
    $m add radiobutton -label [LanguageToName de] \
	-variable ds9(language,name) -command "set ds9(language) de"
    $m add radiobutton -label [LanguageToName en] \
	-variable ds9(language,name) -command "set ds9(language) en"
    $m add radiobutton -label [LanguageToName es] \
	-variable ds9(language,name) -command "set ds9(language) es"
   $m add radiobutton -label [LanguageToName fr] \
	-variable ds9(language,name) -command "set ds9(language) fr"
    $m add radiobutton -label [LanguageToName ja] \
        -variable ds9(language,name) -command "set ds9(language) ja"
    $m add radiobutton -label [LanguageToName pt] \
	-variable ds9(language,name) -command "set ds9(language) pt"

    # --Font
    label $f.tfont -text [msgcat::mc {Menu Font}]
    menubutton $f.font -relief raised \
	-textvariable ds9(font) -menu $f.font.menu

    set m $f.font.menu
    DefaultFontMenu $m ds9(font) ds9(font,size) ds9(font,style) {}
    $m insert 0 radiobutton -label [msgcat::mc {Default}] \
	-variable ds9(font) -value default
    $m insert 1 separator

    # --BG Color
    label $f.tbg -text [msgcat::mc {Background Color}]
    menubutton $f.bg -relief raised \
	-textvariable ds9(bg,color) -menu $f.bg.menu

    DefaultColorMenu $f.bg.menu ds9(bg,color) PrefsBkgrColor

    # --NaN Color
    label $f.tnan -text [msgcat::mc {Blank/Inf/NaN Color}]
    menubutton $f.nan -relief raised \
	-textvariable ds9(nan,color) -menu $f.nan.menu

    DefaultColorMenu $f.nan.menu ds9(nan,color) PrefsNaNColor

    grid $f.tlang $f.lang $f.tbg $f.bg -padx 4 -sticky w
    grid $f.tfont $f.font $f.tnan $f.nan -padx 4 -sticky w

    # Horz Graph
    set f $w.view.horz.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Horizontal Graph}]
    checkbutton $f.grid -text [msgcat::mc {Grid}] \
	-variable graph(horz,grid) -command UpdateGraphGrid
    radiobutton $f.linear -text [msgcat::mc {Linear}] \
	-variable graph(horz,log) -value false -command UpdateGraphYAxis
    radiobutton $f.log -text [msgcat::mc {Log}] \
	-variable graph(horz,log) -value true -command UpdateGraphYAxis

    grid $f.title - - -padx 4 -sticky w
    grid $f.grid $f.linear $f.log -padx 4 -sticky w

    # Vert Graph
    set f $w.view.vert.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Vertical Graph}]
    checkbutton $f.grid -text [msgcat::mc {Grid}] \
	-variable graph(vert,grid) -command UpdateGraphGrid
    radiobutton $f.linear -text [msgcat::mc {Linear}] \
	-variable graph(vert,log) -value false -command UpdateGraphYAxis
    radiobutton $f.log -text [msgcat::mc {Log}] \
	-variable graph(vert,log) -value true -command UpdateGraphYAxis

    grid $f.title - - -padx 4 -sticky w
    grid $f.grid $f.linear $f.log -padx 4 -sticky w

    # Dialog Box
    set f $w.view.box.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Dialog Box}]
    radiobutton $f.motif -text {Motif} -variable ds9(dialog) -value motif
    radiobutton $f.windows -text {Windows} -variable ds9(dialog) -value windows

    grid $f.title -padx 4 -sticky w
    grid $f.motif $f.windows -padx 4 -sticky w

    switch $ds9(wm) {
	x11 {}
	win32 -
	aqua {
	    radiobutton $f.native -text [msgcat::mc {Native Dialog}] \
		-variable ds9(dialog) -value native
	    grid $f.native -row 1 -column 2 -padx 4 -sticky w
	}
    }

    # Panner
    set f $w.view.panner.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Panner}]
    checkbutton $f.orient \
	-text [msgcat::mc {Orientation Compass}] \
	-variable panner(compass,image) -command PrefsImageCompass
    checkbutton $f.wcs -text [msgcat::mc {WCS Compass}] \
	-variable panner(compass,wcs) -command PrefsWCSCompass
    menubutton $f.coord -relief raised \
	-text [msgcat::mc {Coordinate System}] -menu $f.coord.menu

    grid $f.title -padx 4 -sticky w
    grid $f.orient $f.wcs $f.coord -padx 4 -sticky w

    DefaultWCSCoordMenu2 $f.coord.menu \
	panner(compass,wcs,system) panner(compass,wcs,sky) PrefsWCSCompass

    # Magnifier
    set f $w.view.magnifier.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Magnifier}]
    checkbutton $f.graphics -text [msgcat::mc {Graphics}] \
	-variable magnifier(region) -command PrefsMagnifierRegion
    checkbutton $f.cursor -text [msgcat::mc {Cursor}] \
	-variable magnifier(cursor) -command PrefsMagnifierCursor

    radiobutton $f.x1 -text {1x} \
	-variable magnifier(zoom) -value 1 -command PrefsMagnifierZoom
    radiobutton $f.x2 -text {2x} \
	-variable magnifier(zoom) -value 2 -command PrefsMagnifierZoom
    radiobutton $f.x4 -text {4x} \
	-variable magnifier(zoom) -value 4 -command PrefsMagnifierZoom
    radiobutton $f.x8 -text {8x} \
	-variable magnifier(zoom) -value 8 -command PrefsMagnifierZoom
    radiobutton $f.x16 -text {16x} \
	-variable magnifier(zoom) -value 16 -command PrefsMagnifierZoom

    grid $f.title - -padx 4 -sticky w 
    grid $f.graphics $f.cursor -padx 4 -sticky w
    grid $f.x1 $f.x2 $f.x4 $f.x8 $f.x16 -padx 4 -sticky w
}

# Buttons

proc ButtonsVarsView {} {
    global buttons

    array set buttons {
	view,horizontal 0
	view,vertical 0
	view,info 1
	view,panner 1
	view,magnifier 1
	view,buttons 1
	view,colorbar 1
	view,graphhorz 1
	view,graphvert 1
	view,filename 0
	view,object 0
	view,minmax 0
	view,lowhigh 0
	view,frame 0
	view,wcs 0
	view,image 0
	view,physical 0
	view,amplifier 0
	view,detector 0
	view,numerics 0
    }
}

proc CreateButtonsView {} {
    global buttons
    global ds9
    global view

    frame $ds9(buttons).view

    RadioButton $ds9(buttons).view.horizontal \
	[string tolower [msgcat::mc {Horizontal Layout}]] \
	view(layout) horizontal {LayoutViewReset; UpdateView}
    RadioButton $ds9(buttons).view.vertical \
	[string tolower [msgcat::mc {Vertical Layout}]] \
	view(layout) vertical {LayoutViewReset; UpdateView}

    CheckButton $ds9(buttons).view.info \
	[string tolower [msgcat::mc {Information}]] \
	view(info) UpdateView
    CheckButton $ds9(buttons).view.panner \
	[string tolower [msgcat::mc {Panner}]] \
	view(panner) UpdateView
    CheckButton $ds9(buttons).view.magnifier \
	[string tolower [msgcat::mc {Magnifier}]] \
	view(magnifier) UpdateView
    CheckButton $ds9(buttons).view.buttons \
	[string tolower [msgcat::mc {Buttons}]] \
	view(buttons) UpdateView
    CheckButton $ds9(buttons).view.colorbar \
	[string tolower [msgcat::mc {Colorbar}]] \
	view(colorbar) UpdateView
    CheckButton $ds9(buttons).view.graphhorz \
	[string tolower [msgcat::mc {Horizontal}]] \
	view(graph,horz) UpdateView
    CheckButton $ds9(buttons).view.graphvert \
	[string tolower [msgcat::mc {Vertical}]] \
	view(graph,vert) UpdateView

    CheckButton $ds9(buttons).view.filename \
	[string tolower [msgcat::mc {Filename}]] \
	view(info,filename) UpdateView
    CheckButton $ds9(buttons).view.object \
	[string tolower [msgcat::mc {Object}]] \
	view(info,object) UpdateView
    CheckButton $ds9(buttons).view.minmax \
	[string tolower [msgcat::mc {Min Max}]] \
	view(info,minmax) UpdateView
    CheckButton $ds9(buttons).view.lowhigh \
	[string tolower [msgcat::mc {Low High}]] \
	view(info,lowhigh) UpdateView
    CheckButton $ds9(buttons).view.frame \
	[string tolower [msgcat::mc {Frame}]] \
	view(info,frame) UpdateView
    CheckButton $ds9(buttons).view.wcs \
	[string tolower [msgcat::mc {WCS}]] \
	view(info,wcs) UpdateView
    CheckButton $ds9(buttons).view.image \
	[string tolower [msgcat::mc {Image}]] \
	view(info,image) UpdateView
    CheckButton $ds9(buttons).view.physical \
	[string tolower [msgcat::mc {Physical}]] \
	view(info,physical) UpdateView
    CheckButton $ds9(buttons).view.amplifier \
	[string tolower [msgcat::mc {Amplifier}]] \
	view(info,amplifier) UpdateView
    CheckButton $ds9(buttons).view.detector \
	[string tolower [msgcat::mc {Detector}]] \
	view(info,detector) UpdateView

    CheckButton $ds9(buttons).view.numerics \
	[string tolower [msgcat::mc {Numerics}]] \
	view(colorbar,numerics) UpdateView

    set buttons(view) "
        $ds9(buttons).view.horizontal buttons(view,horizontal)
        $ds9(buttons).view.vertical buttons(view,vertical)
        $ds9(buttons).view.info buttons(view,info)
        $ds9(buttons).view.panner buttons(view,panner)
        $ds9(buttons).view.magnifier buttons(view,magnifier)
        $ds9(buttons).view.buttons buttons(view,buttons)
        $ds9(buttons).view.colorbar buttons(view,colorbar)
        $ds9(buttons).view.graphhorz buttons(view,graphhorz)
        $ds9(buttons).view.graphvert buttons(view,graphvert)
        $ds9(buttons).view.filename buttons(view,filename)
        $ds9(buttons).view.object buttons(view,object)
        $ds9(buttons).view.minmax buttons(view,minmax)
        $ds9(buttons).view.lowhigh buttons(view,lowhigh)
        $ds9(buttons).view.frame buttons(view,frame)
        $ds9(buttons).view.wcs buttons(view,wcs)
        $ds9(buttons).view.image buttons(view,image)
        $ds9(buttons).view.physical buttons(view,physical)
        $ds9(buttons).view.amplifier buttons(view,amplifier)
        $ds9(buttons).view.detector buttons(view,detector)
        $ds9(buttons).view.numerics buttons(view,numerics)
    "
}

proc PrefsDialogButtonbarView {f} {
    global buttons

    menubutton $f -relief raised -text [msgcat::mc {View}] -menu $f.menu
    
    set m $f.menu
    menu $m
    $m add checkbutton -label [msgcat::mc {Horizontal Layout}] \
	-variable buttons(view,horizontal) \
	-command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {Vertical Layout}] \
	-variable buttons(view,vertical) \
	-command {UpdateButtons buttons(view)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Information Panel}] \
	-variable buttons(view,info) -command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {Panner}] \
	-variable buttons(view,panner) -command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {Magnifier}] \
	-variable buttons(view,magnifier) -command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {Buttons}] \
	-variable buttons(view,buttons) -command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {Colorbar}] \
	-variable buttons(view,colorbar) -command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {Horizontal Graph}] \
	-variable buttons(view,graphhorz) \
	-command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {Vertical Graph}] \
	-variable buttons(view,graphvert) \
	-command {UpdateButtons buttons(view)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Filename}] \
	-variable buttons(view,filename) -command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {Object}] \
	-variable buttons(view,object) -command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {Min Max}] \
	-variable buttons(view,minmax) -command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {Low High}] \
	-variable buttons(view,lowhigh) -command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {Frame Information}] \
	-variable buttons(view,frame) -command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {WCS}] \
	-variable buttons(view,wcs) -command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {Image}] \
	-variable buttons(view,image) -command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {Physical}] \
	-variable buttons(view,physical) -command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {Amplifier}] \
	-variable buttons(view,amplifier) -command {UpdateButtons buttons(view)}
    $m add checkbutton -label [msgcat::mc {Detector}] \
	-variable buttons(view,detector) -command {UpdateButtons buttons(view)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Colorbar Numerics}] \
	-variable buttons(view,numerics) -command {UpdateButtons buttons(view)}
}
