#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

# Menus

proc ZoomMenu {} {
    global ds9

    menu $ds9(mb).zoom
    $ds9(mb).zoom add command -label [msgcat::mc {Center Image}] \
	-command CenterCurrentFrame
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add checkbutton -label [msgcat::mc {Align}] \
	-variable wcs(align) -command AlignWCSFrame
    $ds9(mb).zoom add cascade -label [msgcat::mc {Align WCS}] \
	-menu $ds9(mb).zoom.align
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add command -label [msgcat::mc {Zoom In}] \
	-command {Zoom 2 2}
    $ds9(mb).zoom add command -label [msgcat::mc {Zoom Out}] \
	-command {Zoom .5 .5}
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add command -label [msgcat::mc {Zoom to Fit Frame}] \
	-command ZoomToFit
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 1/32" \
	-variable current(zoom) -value { 0.03125 0.03125 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 1/16" \
	-variable current(zoom) -value { 0.0625 0.0625 }  -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 1/8" \
	-variable current(zoom) -value { 0.125 0.125 }  -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 1/4" \
	-variable current(zoom) -value { 0.25 0.25 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 1/2" \
	-variable current(zoom) -value { 0.5 0.5 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 1" \
	-variable current(zoom) -value { 1 1 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 2" \
	-variable current(zoom) -value { 2 2 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 4" \
	-variable current(zoom) -value { 4 4 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 8" \
	-variable current(zoom) -value { 8 8 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 16" \
	-variable current(zoom) -value { 16 16 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 32" \
	-variable current(zoom) -value { 32 32 } -command ChangeZoom
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add radiobutton -label [msgcat::mc {None}] \
	-variable current(orient) -value none -command ChangeOrient
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Invert}] X" \
	-variable current(orient) -value x -command ChangeOrient
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Invert}] Y" \
	-variable current(orient) -value y -command ChangeOrient
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Invert}] XY" \
	-variable current(orient) -value xy -command ChangeOrient
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add radiobutton -label "0 [msgcat::mc {Degrees}]" \
	-variable current(rotate) -value 0 -command ChangeRotate
    $ds9(mb).zoom add radiobutton -label "90 [msgcat::mc {Degrees}]" \
	-variable current(rotate) -value 90 -command ChangeRotate
    $ds9(mb).zoom add radiobutton -label "180 [msgcat::mc {Degrees}]" \
	-variable current(rotate) -value 180 -command ChangeRotate
    $ds9(mb).zoom add radiobutton -label "270 [msgcat::mc {Degrees}]" \
	-variable current(rotate) -value 270 -command ChangeRotate
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add command \
	-label "[msgcat::mc {Pan Zoom Rotate Parameters}]..." \
	-command PanZoomDialog

    DefaultWCSCoordMenu2 $ds9(mb).zoom.align \
	wcs(align,system) wcs(align,sky) AlignWCSFrame
}

proc PrefsDialogZoom {} {
    global prefs

    set w $prefs(tabs)

    frame $w.zoom
    $prefs(tabs) tab configure zoom -window $w.zoom -fill both

    frame $w.zoom.menu -relief ridge -bd 1
    frame $w.zoom.mode -relief ridge -bd 1
    pack $w.zoom.menu $w.zoom.mode -side top -fill both -expand true

    # Buttons
    PrefsDialogButtons $w.zoom

    # Menu
    set f $w.zoom.menu.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Default Menu}]
    menubutton $f.zoom -relief raised -text [msgcat::mc {Zoom}] \
	-menu $f.zoom.menu

    grid $f.title $f.zoom -padx 4 -sticky w
    
    set m $f.zoom.menu
    menu $m
    $m add checkbutton -label [msgcat::mc {Align}] -variable pwcs(align)
    $m add cascade -label [msgcat::mc {Align WCS}] -menu $m.align
    $m add separator
    $m add radiobutton -label "[msgcat::mc {Zoom}] 1/32" \
	-variable prefs(zoom) -value { 0.03125 0.03125 }
    $m add radiobutton -label "[msgcat::mc {Zoom}] 1/16" \
	-variable prefs(zoom) -value { 0.0625 0.0625 }
    $m add radiobutton -label "[msgcat::mc {Zoom}] 1/8" \
	-variable prefs(zoom) -value { 0.125 0.125 }
    $m add radiobutton -label "[msgcat::mc {Zoom}] 1/4" \
	-variable prefs(zoom) -value { 0.25 0.25 }
    $m add radiobutton -label "[msgcat::mc {Zoom}] 1/2" \
	-variable prefs(zoom) -value { 0.5 0.5 }
    $m add radiobutton -label "[msgcat::mc {Zoom}] 1" \
	-variable prefs(zoom) -value { 1 1 }
    $m add radiobutton -label "[msgcat::mc {Zoom}] 2" \
	-variable prefs(zoom) -value { 2 2 }
    $m add radiobutton -label "[msgcat::mc {Zoom}] 4" \
	-variable prefs(zoom) -value { 4 4 }
    $m add radiobutton -label "[msgcat::mc {Zoom}] 8" \
	-variable prefs(zoom) -value { 8 8 }
    $m add radiobutton -label "[msgcat::mc {Zoom}] 16" \
	-variable prefs(zoom) -value { 16 16 }
    $m add radiobutton -label "[msgcat::mc {Zoom}] 32" \
	-variable prefs(zoom) -value { 32 32 }
    $m add separator
    $m add radiobutton -label [msgcat::mc {None}] \
	-variable prefs(orient) -value none
    $m add radiobutton -label "[msgcat::mc {Invert}] X" \
	-variable prefs(orient) -value x
    $m add radiobutton -label "[msgcat::mc {Invert}] Y" \
	-variable prefs(orient) -value y
    $m add radiobutton -label "[msgcat::mc {Invert}] XY" \
	-variable prefs(orient) -value xy
    $m add separator
    $m add radiobutton -label "0 [msgcat::mc {Degrees}]" \
	-variable prefs(rotate) -value 0 
    $m add radiobutton -label "90 [msgcat::mc {Degrees}]" \
	-variable prefs(rotate) -value 90
    $m add radiobutton -label "180 [msgcat::mc {Degrees}]" \
	-variable prefs(rotate) -value 180
    $m add radiobutton -label "270 [msgcat::mc {Degrees}]" \
	-variable prefs(rotate) -value 270

    DefaultWCSCoordMenu2 $m.align pwcs(align,system) pwcs(align,sky) {}

    # Mode
    set f $w.zoom.mode.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Pan Zoom}]
    radiobutton $f.click -text [msgcat::mc {Click to Center}] \
	-variable panzoom(mode) -value click
    radiobutton $f.drag -text [msgcat::mc {Drag to Center}] \
	-variable panzoom(mode) -value drag
    radiobutton $f.panzoom -text [msgcat::mc {Pan then Zoom}] \
	-variable panzoom(mode) -value panzoom

    grid $f.title -padx 4 -sticky w
    grid $f.click $f.drag $f.panzoom -padx 4 -sticky w
}

# Buttons

proc ButtonsVarsZoom {} {
    global buttons

    array set buttons {
	zoom,center 0 
	zoom,align 0
	zoom,in 1
	zoom,out 1
	zoom,fit 1

	zoom,1/32 0
	zoom,1/16 0
	zoom,1/8 1
	zoom,1/4 1
	zoom,1/2 1
	zoom,1 1
	zoom,2 1
	zoom,4 1
	zoom,8 1
	zoom,16 0
	zoom,32 0

	zoom,none 0
	zoom,x 0
	zoom,y 0
	zoom,xy 0

	zoom,0 0
	zoom,90 0
	zoom,180 0
	zoom,270 0

	zoom,params 0
    }
}

proc CreateButtonsZoom {} {
    global buttons
    global ds9
    global wcs

    frame $ds9(buttons).zoom

    ButtonButton $ds9(buttons).zoom.center \
	[string tolower [msgcat::mc {Center}]] CenterCurrentFrame
    CheckButton $ds9(buttons).zoom.align \
	[msgcat::mc {Align}] wcs(align) AlignWCSFrame
    ButtonButton $ds9(buttons).zoom.in {-} {Zoom .5 .5}
    ButtonButton $ds9(buttons).zoom.out {+} {Zoom 2 2}
    ButtonButton $ds9(buttons).zoom.fit \
	[string tolower [msgcat::mc {To Fit}]] ZoomToFit

    RadioButton $ds9(buttons).zoom.z132 \
	"[string tolower [msgcat::mc {Zoom}]] 1/32" \
	     current(zoom) { 0.03125 0.03125 } ChangeZoom
    RadioButton $ds9(buttons).zoom.z116 \
	"[string tolower [msgcat::mc {Zoom}]] 1/16" \
	     current(zoom) { 0.0625 0.0625 } ChangeZoom
    RadioButton $ds9(buttons).zoom.z18 \
	"[string tolower [msgcat::mc {Zoom}]] 1/8" \
	     current(zoom) { 0.125 0.125 } ChangeZoom
    RadioButton $ds9(buttons).zoom.z14 \
	"[string tolower [msgcat::mc {Zoom}]] 1/4" \
	     current(zoom) { 0.25 0.25 } ChangeZoom
    RadioButton $ds9(buttons).zoom.z12 \
	"[string tolower [msgcat::mc {Zoom}]] 1/2" \
	     current(zoom) { 0.5 0.5 } ChangeZoom
    RadioButton $ds9(buttons).zoom.z1 \
	"[string tolower [msgcat::mc {Zoom}]] 1" \
	     current(zoom) { 1 1 } ChangeZoom
    RadioButton $ds9(buttons).zoom.z2 \
	"[string tolower [msgcat::mc {Zoom}]] 2" \
	     current(zoom) { 2 2 } ChangeZoom
    RadioButton $ds9(buttons).zoom.z4 \
	"[string tolower [msgcat::mc {Zoom}]] 4" \
	current(zoom) { 4 4 } ChangeZoom
    RadioButton $ds9(buttons).zoom.z8 \
	"[string tolower [msgcat::mc {Zoom}]] 8" \
	current(zoom) { 8 8 } ChangeZoom
    RadioButton $ds9(buttons).zoom.z16 \
	"[string tolower [msgcat::mc {Zoom}]] 16" \
	current(zoom) { 16 16 } ChangeZoom
    RadioButton $ds9(buttons).zoom.z32 \
	"[string tolower [msgcat::mc {Zoom}]] 32" \
	current(zoom) { 32 32 } ChangeZoom

    RadioButton $ds9(buttons).zoom.none \
	[string tolower [msgcat::mc {None}]] \
	current(orient) none ChangeOrient
    RadioButton $ds9(buttons).zoom.x {x} current(orient) x ChangeOrient
    RadioButton $ds9(buttons).zoom.y {y} current(orient) y ChangeOrient
    RadioButton $ds9(buttons).zoom.xy {xy} current(orient) xy ChangeOrient

    RadioButton $ds9(buttons).zoom.0 {0} current(rotate) 0 ChangeRotate
    RadioButton $ds9(buttons).zoom.90 {90} current(rotate) 90 ChangeRotate
    RadioButton $ds9(buttons).zoom.180 {180} current(rotate) 180 ChangeRotate
    RadioButton $ds9(buttons).zoom.270 {270} current(rotate) 270 ChangeRotate

    ButtonButton $ds9(buttons).zoom.params \
	[string tolower [msgcat::mc {Parameters}]] PanZoomDialog

    set buttons(zoom) "
        $ds9(buttons).zoom.center buttons(zoom,center)
	$ds9(buttons).zoom.align buttons(zoom,align)
	$ds9(buttons).zoom.in buttons(zoom,in)
	$ds9(buttons).zoom.out buttons(zoom,out)
	$ds9(buttons).zoom.fit buttons(zoom,fit)

	$ds9(buttons).zoom.z132 buttons(zoom,1/32)
	$ds9(buttons).zoom.z116 buttons(zoom,1/16)
	$ds9(buttons).zoom.z18 buttons(zoom,1/8)
	$ds9(buttons).zoom.z14 buttons(zoom,1/4)
	$ds9(buttons).zoom.z12 buttons(zoom,1/2)
	$ds9(buttons).zoom.z1 buttons(zoom,1)
	$ds9(buttons).zoom.z2 buttons(zoom,2)
	$ds9(buttons).zoom.z4 buttons(zoom,4)
	$ds9(buttons).zoom.z8 buttons(zoom,8)
	$ds9(buttons).zoom.z16 buttons(zoom,16)
	$ds9(buttons).zoom.z32 buttons(zoom,32)

	$ds9(buttons).zoom.none buttons(zoom,none)
	$ds9(buttons).zoom.x buttons(zoom,x)
	$ds9(buttons).zoom.y buttons(zoom,y)
	$ds9(buttons).zoom.xy buttons(zoom,xy)

	$ds9(buttons).zoom.0 buttons(zoom,0)
	$ds9(buttons).zoom.90 buttons(zoom,90)
	$ds9(buttons).zoom.180 buttons(zoom,180)
	$ds9(buttons).zoom.270 buttons(zoom,270)

	$ds9(buttons).zoom.params buttons(zoom,params)
    "
}

proc PrefsDialogButtonbarZoom {f} {
    global buttons

    menubutton $f -relief raised -text [msgcat::mc {Zoom}] -menu $f.menu
    
    set m $f.menu
    menu $m
    $m add checkbutton -label [msgcat::mc {Center Image}] \
	-variable buttons(zoom,center) -command {UpdateButtons buttons(zoom)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Align}] \
	-variable buttons(zoom,align) -command {UpdateButtons buttons(zoom)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Zoom In}] \
	-variable buttons(zoom,in) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label [msgcat::mc {Zoom Out}] \
	-variable buttons(zoom,out) -command {UpdateButtons buttons(zoom)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Zoom to Fit Frame}] \
	-variable buttons(zoom,fit) -command {UpdateButtons buttons(zoom)}
    $m add separator
    $m add checkbutton -label "[msgcat::mc {Zoom}] 1/32" \
	-variable buttons(zoom,1/32) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "[msgcat::mc {Zoom}] 1/16" \
	-variable buttons(zoom,1/16) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "[msgcat::mc {Zoom}] 1/8" \
	-variable buttons(zoom,1/8) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "[msgcat::mc {Zoom}] 1/4" \
	-variable buttons(zoom,1/4) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "[msgcat::mc {Zoom}] 1/2" \
	-variable buttons(zoom,1/2) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "[msgcat::mc {Zoom}] 1" \
	-variable buttons(zoom,1) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "[msgcat::mc {Zoom}] 2" \
	-variable buttons(zoom,2) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "[msgcat::mc {Zoom}] 4" \
	-variable buttons(zoom,4) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "[msgcat::mc {Zoom}] 8" \
	-variable buttons(zoom,8) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "[msgcat::mc {Zoom}] 16" \
	-variable buttons(zoom,16) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "[msgcat::mc {Zoom}] 32" \
	-variable buttons(zoom,32) -command {UpdateButtons buttons(zoom)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {None}] \
	-variable buttons(zoom,none) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "[msgcat::mc {Invert}] X" \
	-variable buttons(zoom,x) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "[msgcat::mc {Invert}] Y" \
	-variable buttons(zoom,y) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "[msgcat::mc {Invert}] XY" \
	-variable buttons(zoom,xy) -command {UpdateButtons buttons(zoom)}
    $m add separator
    $m add checkbutton -label "0 [msgcat::mc {Degrees}]" \
	-variable buttons(zoom,0) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "90 [msgcat::mc {Degrees}]" \
	-variable buttons(zoom,90) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "180 [msgcat::mc {Degrees}]" \
	-variable buttons(zoom,180) -command {UpdateButtons buttons(zoom)}
    $m add checkbutton -label "270 [msgcat::mc {Degrees}]" \
	-variable buttons(zoom,270) -command {UpdateButtons buttons(zoom)}
    $m add separator
    $m add checkbutton -label "[msgcat::mc {Pan Zoom Rotate Parameters}]..." \
	-variable buttons(zoom,params) -command {UpdateButtons buttons(zoom)}
}

# Support

proc UpdateZoomMenu {} {
    global ds9
    global current
    global wcs
    global panzoom
    
    global debug
    if {$debug(tcl,update)} {
	puts "UpdateZoomMenu"
    }

    UpdateAlignWCSMenu $ds9(mb).zoom

    if {$current(frame) != {}} {
	$ds9(mb) entryconfig [msgcat::mc {Zoom}] -state normal
	$ds9(buttons).major.zoom configure -state normal

	set panzoom(preserve) [$current(frame) get pan preserve]

	set current(zoom) [$current(frame) get zoom]
	set current(rotate) [$current(frame) get rotate]
	set current(orient) [$current(frame) get orient]

	set align [$current(frame) get wcs align]
	set wcs(align) [lindex $align 0]
	set wcs(align,system) [lindex $align 1]
	set wcs(align,sky) [lindex $align 2]
    } else {
	$ds9(mb) entryconfig [msgcat::mc {Zoom}] -state disabled
	$ds9(buttons).major.zoom configure -state disabled
    }
}

proc UpdateAlignWCSMenu {which} {
    global current
    global wcs

    # no frame
    if {$current(frame) == {}} {
	$which entryconfig [msgcat::mc {Align}] -state disabled
	$which entryconfig [msgcat::mc {Align WCS}] -state disabled
	return
    }

    # unloaded frame
    if {![$current(frame) has fits]} {
	$which entryconfig [msgcat::mc {Align}]  -state normal
	$which entryconfig [msgcat::mc {Align WCS}] -state normal

	$which.align entryconfig [msgcat::mc {WCS}] -state normal
	$which.align entryconfig [msgcat::mc {Multiple WCS}] -state normal

	$which.align entryconfig "[msgcat::mc {Equatorial}] B1950" \
	    -state normal
	$which.align entryconfig "[msgcat::mc {Equatorial}] J2000" \
	    -state normal
	$which.align entryconfig [msgcat::mc {ICRS}] -state normal
	$which.align entryconfig [msgcat::mc {Galactic}] -state normal
	$which.align entryconfig [msgcat::mc {Ecliptic}] -state normal

	foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	    $which.align.wcs entryconfig "[msgcat::mc {WCS}] $l" \
		-state normal
	}
	return
    }

    # loaded frame
    $which entryconfig [msgcat::mc {Align}] -state normal
    $which entryconfig [msgcat::mc {Align WCS}] -state normal

    if {[$current(frame) has wcs WCS]} {
	$which.align entryconfig [msgcat::mc {WCS}] -state normal
    } else {
	$which.align entryconfig [msgcat::mc {WCS}] -state disabled
    }
    $which.align entryconfig [msgcat::mc {Multiple WCS}] -state normal
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	if {[$current(frame) has wcs WCS$l]} {
	    $which.align.wcs entryconfig "[msgcat::mc {WCS}] $l" \
		-state normal
	} else {
	    $which.align.wcs entryconfig "[msgcat::mc {WCS}] $l" \
		-state disabled
	}
    }

    SetSkyFrameMenu2 $which.align disabled

    if {$current(frame) != {}} {
	if {[$current(frame) has fits]} {
	    switch -- $wcs(align,system) {
		wcs {}
		default {
		    if {![$current(frame) has wcs $wcs(align,system)]} {
			    set wcs(align,system) wcs
		    }
		}
	    }

	    if [$current(frame) has wcs equatorial $wcs(align,system)] {
		SetSkyFrameMenu2 $which.align normal
	    }
	}
    }
}
