#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc PointDialog {frame id} {
    global marker

    set w ".marker$id"

    # see if we already have a header window visible
    if [winfo exists $w] {
	raise $w
	return
    }

    # base
    MarkerBaseCenterDialog $frame $id 375 100

    # init
    set marker($frame,$id,size) [$frame get marker $id point size]

    # size
    label $w.ref.f.sizeTitle -text [msgcat::mc {Size}]
    entry $w.ref.f.size -textvariable marker($frame,$id,size) -width 13 
    label $w.ref.f.sizeformat -text [msgcat::mc {Pixels}] -padx 4
    grid $w.ref.f.sizeTitle $w.ref.f.size x $w.ref.f.sizeformat \
	-padx 4 -sticky w
}

# actions

proc PointClose {frame id} {
    MarkerBaseCenterClose $frame $id
}

proc PointApply {frame id} {
    global marker

    $frame marker $id point size $marker($frame,$id,size)

    MarkerBaseCenterApply $frame $id
}

# callbacks

proc PointCoordCB {frame id} {
    global debug
    if {$debug(tcl,marker)} {
	puts "PointCoordCB"
    }
    MarkerBaseCoordCB $frame $id
    MarkerBaseCenterMoveCB $frame $id
}





