#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc PolygonDialog {frame id} {
    global marker

    set w ".marker$id"

    # see if we already have a header window visible
    if [winfo exists $w] {
	raise $w
	return
    }

    # base
    MarkerBaseCenterDialog $frame $id 375 125

    # init
    MarkerBaseCenterRotateCB $frame $id

    # callbacks
    $frame marker $id callback rotate MarkerBaseCenterRotateCB $frame

    # Angle
    label $w.ref.f.angleTitle -text [msgcat::mc {Angle}]
    entry $w.ref.f.angle -textvariable marker($frame,$id,angle) -width 13
    label $w.ref.f.angleUnit -padx 4 -text [msgcat::mc {Degrees}]

    grid $w.ref.f.angleTitle $w.ref.f.angle x $w.ref.f.angleUnit \
	-padx 4 -sticky w
}

# actions

proc PolygonClose {frame id} {
    $frame marker $id delete callback rotate MarkerBaseCenterRotateCB
    MarkerBaseCenterClose $frame $id
}

proc PolygonApply {frame id} {
    MarkerBaseCenterRotate $frame $id
    MarkerBaseCenterApply $frame $id
}

# callbacks

proc PolygonCoordCB {frame id} {
    global debug
    if {$debug(tcl,marker)} {
	puts "PolygonCoordCB"
    }
    MarkerBaseCoordCB $frame $id
    MarkerBaseCenterMoveCB $frame $id
    MarkerBaseCenterRotateCB $frame $id
}

