#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc SaveState {} {
    global ds9

    set fn [SaveFileDialog statefbox]
    if {[string length $fn] == 0} {
	return
    }

    set ch [open $fn w]
    if {$ch == {}} {
	Error [msgcat::mc {An error has occurred while saving}]
	return
    }

    # basic geometry
    foreach f $ds9(frames) {
	SaveStateFrame $ch $f
    }

    close $ch
}

proc LoadState {} {
    set fn [OpenFileDialog statefbox]
    if {[string length $fn] == 0} {
	return
    }

    # clear all frames
    DeleteAllFrames

    # and the rest?
    # analysis plot
    # analysis text
    # user plot
    # catalogs
    # hvs

    # and load the world
    if {[catch {source $fn}]} {
	Error [msgcat::mc {An error has occurred while loading}]
	return
    }

    # and update it
    UpdateDS9
}

proc SaveStateFrame {ch which} {
    set type [$which get type]
    puts $ch "CreateNameNumberFrame $which $type"
}


