#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

# do this after the language has been defined and the prefs sourced
proc InitDialogBox {} {
    global ds9
    global env

    switch $ds9(wm) {
	x11 {}
	win32 {set ds9(dialog,dir) [GetEnvHome]}
	aqua {
	    switch -- $ds9(dialog) {
		native {}
		motif -
		windows {
		    # try to determine if invoked from 
		    # command line or double click
		    if {![info exists env(TERM)]} {
			set ds9(dialog,dir) [GetEnvHome]
		    }
		}
	    }
	}
    }

    global fitsfbox
    set fitsfbox(file) {}
    set fitsfbox(types) [list \
			     [list {FITS} {*.fits}] \
			     [list {FITS} {*.FITS}] \
			     [list {FITS} {*.fit}] \
			     [list {FITS} {*.FIT}] \
			     [list {FITS} {*.fts}] \
			     [list {FITS} {*.FTS}] \
			     [list {FITS} {*.ds}] \
			     [list {FITS} {*.DS}] \
			     [list {FITS} {*.fits.gz}] \
			     [list {FITS} {*.fits.bz2}] \
			     [list {FITS} {*.fits.Z}] \
			     [list {FITS} {*.fits.z}] \
			     [list {FITS} {*.fitz}] \
			     [list {FITS} {*.FITZ}] \
			     [list {FITS} {*.ftz}] \
			     [list {FITS} {*.FTZ}] \
			     [list {FITS} {*.fz}] \
			     [list {FITS} {*.FZ}] \
			     [list [::msgcat::mc {All}] {*}] \
			    ]

    global fitsvarfbox
    set fitsvarfbox(file) {}
    set fitsvarfbox(types) [list [list [::msgcat::mc {All}] {*}] ]

    global arrayfbox
    set arrayfbox(file) {}
    set arrayfbox(types) \
	[list [list {ARR} {*.arr}] [list [::msgcat::mc {All}] {*}] ]

    global imagefbox
    set imagefbox(file) {}
    set imagefbox(types) [list \
			      [list {GIF} {*.gif}] \
			      [list {JPEG} {*.jpeg}] \
			      [list {JPEG} {*.jpg}] \
			      [list {TIFF} {*.tiff}] \
			      [list {TIFF} {*.tif}] \
			      [list {PNG} {*.png}] \
			      [list {PPM} {*.ppm}] \
			      [list [::msgcat::mc {All}] {*}] \
			     ]

    global pixelfbox
    set pixelfbox(file) {ds9.pix}
    set pixelfbox(types) \
	[list [list {PIX} {*.pix}] [list [::msgcat::mc {All}] {*}] ]

    global markerfbox
    set markerfbox(file) {ds9.reg}
    set markerfbox(types) [list \
			       [list {REG} {*.reg}] \
			       [list {FITS} {*.fits}] \
			       [list [::msgcat::mc {All}] {*}] \
			      ]

    global templatefbox
    set templatefbox(file) {ds9.tpl}
    set templatefbox(types) \
	[list [list {TPL} {*.tpl}] [list [::msgcat::mc {All}] {*}] ]

    global colorbarfbox
    set colorbarfbox(file) {}
    set colorbarfbox(types) [list \
				 [list [::msgcat::mc {Colormap}] {*.sao}] \
				 [list [::msgcat::mc {Colormap}]  {*.lut}] \
				 [list [::msgcat::mc {All}] {*}] \
				]

    global contrastbiasfbox
    set contrastbiasfbox(file) {ds9.cb}
    set contrastbiasfbox(types) \
	[list [list {CB} {*.cb}] [list [::msgcat::mc {All}] {*}] ]

    global pssavfbox
    set pssavfbox(file) {ds9.ps}
    set pssavfbox(types) \
	[list [list {PS} {*.ps}] [list [::msgcat::mc {All}] {*}] ]

    global contourfbox
    set contourfbox(file) {ds9.con}
    set contourfbox(types) \
	[list [list {CON} {*.con}] [list [::msgcat::mc {All}] {*}] ]

    global contourlevfbox
    set contourlevfbox(file) {ds9.lev}
    set contourlevfbox(types) \
	[list [list {LEV} {*.lev}] [list [::msgcat::mc {All}] {*}] ]

    global gridfbox
    set gridfbox(file) {ds9.grd}
    set gridfbox(types) \
	[list [list {GRD} {*.grd}] [list [::msgcat::mc {All}] {*}] ]

    global catfbox
    set catfbox(file) {ds9.cat}
    set catfbox(types) [list \
			    [list [::msgcat::mc {Catalog}] {*.cat}] \
			    [list [::msgcat::mc {Catalog}] {*.rdb}] \
			    [list [::msgcat::mc {All}] {*}] \
			   ]

    global catcsvfbox
    set catcsvfbox(file) {ds9.csv}
    set catcsvfbox(types) [list \
			       [list [::msgcat::mc {Catalog}] {*.cat}] \
			       [list [::msgcat::mc {Catalog}] {*.csv}] \
			       [list [::msgcat::mc {All}] {*}] \
			      ]

    global catfltfbox
    set catfltfbox(file) {ds9.flt}
    set catfltfbox(types) \
	[list [list {FLT} {*.flt}] [list [::msgcat::mc {All}] {*}] ]

    global catsymfbox
    set catsymfbox(file) {ds9.sym}
    set catsymfbox(types) \
	[list [list {SYM} {*.sym}] [list [::msgcat::mc {All}] {*}] ]

    global catcdssrchfbox
    set catcdssrchfbox(file) {ds9.cds}
    set catcdssrchfbox(types) \
	[list [list {CDS} {*.cds}] [list [::msgcat::mc {All}] {*}] ]

    global analysisfbox
    set analysisfbox(file) {ds9.ans}
    set analysisfbox(types) [list \
				 [list [::msgcat::mc {Analysis}] {*.ans}] \
				 [list [::msgcat::mc {Analysis}] {*.ds9}] \
				 [list [::msgcat::mc {All}] {*}] \
				]

    global apdatafbox
    set apdatafbox(file) {ds9.dat}
    set apdatafbox(types) \
	[list [list {DAT} {*.dat}] [list [::msgcat::mc {All}] {*}] ]

    global apconfigfbox
    set apconfigfbox(file) {ds9.plt}
    set apconfigfbox(types) \
	[list [list {PLT} {*.plt}] [list [::msgcat::mc {All}] {*}] ]

    global textfbox
    set textfbox(file) {ds9.txt}
    set textfbox(types) \
	[list [list {TXT} {*.txt}] [list [::msgcat::mc {All}] {*}] ]

    global tclfbox
    set tclfbox(file) {}
    set tclfbox(types) \
	[list [list {TCL} {*.tcl}] [list [::msgcat::mc {All}] {*}] ]

    global hvhtmlfbox
    set hvhtmlfbox(file) {}
    set  hvhtmlfbox(types) [list \
				[list {HTML} {*.html}] \
				[list {HTML} {*.htm}] \
				[list [::msgcat::mc {All}] {*}] \
			       ]

    global saveimagefbox
    set saveimagefbox(file) {ds9}
    set saveimagefbox(types) [list [list [::msgcat::mc {All}] {*}] ]

    global savefitsfbox
    set savefitsfbox(file) {ds9.fits}
    set savefitsfbox(types) [list \
				 [list {FITS} {*.fits}] \
				 [list {FITS} {*.fit}] \
				 [list {FITS} {*.fts}] \
				 [list {FITS} {*.fits.gz}] \
				 [list {FITS} {*.fits.bz2}] \
				 [list {FITS} {*.fits.Z}] \
				 [list {FITS} {*.fits.z}] \
				 [list {FITS} {*.fitz}] \
				 [list {FITS} {*.ftz}] \
				 [list {FITS} {*.fz}] \
				 [list [::msgcat::mc {All}] {*}] \
				]

    global savempegfbox
    set savempegfbox(file) {ds9.mpeg}
    set savempegfbox(types) [list \
				 [list {MPEG} {*.mpeg}] \
				 [list {MPEG} {*.mpg}] \
				 [list [::msgcat::mc {All}] {*}] \
				]
    global tmpdirfbox
    set tmpdirfbox(file) {}
    set tmpdirfbox(types) [list [list [::msgcat::mc {All}] {*}] ]

    global statefbox
    set statefbox(file) {ds9.sav}
    set statefbox(types) \
	[list [list {SAV} {*.sav}] [list [::msgcat::mc {All}] {*}] ]
}

proc OpenFileDialog {varname} {
    return [FileDialog $varname tk_getOpenFile]
}

proc SaveFileDialog {varname} {
    return [FileDialog $varname tk_getSaveFile]
}

proc FileDialog {varname which} {
    global ds9

    switch -- $ds9(dialog) {
	motif {return [FileDialogMotif $varname $which]}
	windows {return [FileDialogWindows $varname $which]}
	native {return [FileDialogNative $varname $which]}
    }
}

proc FileDialogMotif {varname which} {
    upvar #0 $varname var

    global ds9
    global tk_strictMotif

    set tk_strictMotif 1

    switch $ds9(wm) {
	x11 {
	    # Theres a bug with strictmotif. 
	    # If tk_strictMotif is set to 1, buttons are
	    # rendered smaller than if 0.
	    set result [$which \
			    -filetypes $var(types) \
			    -initialdir $ds9(dialog,dir) \
			    -initialfile $var(file) \
			    -parent $ds9(top)]
	}
	win32 -
	aqua {
	    switch -- $which {
		tk_getOpenFile {set type open}
		tk_getSaveFile {set type save}
	    }
	    set result [::tk::MotifFDialog $type \
			    -filetypes $var(types) \
			    -initialdir $ds9(dialog,dir) \
			    -initialfile $var(file) \
			    -parent $ds9(top)]
	}
    }
    set tk_strictMotif 0

    if {$result != {}} {
	set var(file) [file tail $result]
	set ds9(dialog,dir) [file dirname $result]
    }

    return $result
}

proc FileDialogWindows {varname which} {
    upvar #0 $varname var
    global ds9

    switch $ds9(wm) {
	x11 {
	    set result [$which \
			    -filetypes $var(types) \
			    -initialdir $ds9(dialog,dir) \
			    -initialfile $var(file) \
			    -parent $ds9(top)]
	}
	win32 -
	aqua {
	    switch -- $which {
		tk_getOpenFile {set type open}
		tk_getSaveFile {set type save}
	    }
	    set result [::tk::dialog::file:: $type \
			    -filetypes $var(types) \
			    -initialdir $ds9(dialog,dir) \
			    -initialfile $var(file) \
			    -parent $ds9(top)]
	}
    }

    if {$result != {}} {
	set var(file) [file tail $result]
	set ds9(dialog,dir) [file dirname $result]
    }

    return $result
}

proc FileDialogNative {varname which} {
    upvar #0 $varname var
    global ds9

    if [catch {$which \
		   -filetypes $var(types) \
		   -initialdir $ds9(dialog,dir) \
		   -initialfile $var(file) \
		   -parent $ds9(top)} result] {

	# must have a bad file name, just clear and try again
	set var(file) {}
	set ds9(dialog,dir) {}
	if [catch {$which \
		       -filetypes $var(types) \
		       -parent $ds9(top)} result] {

	    #ok, something is really wrong
	    catch {$which -parent $ds9(top)} result
	}
    }

    if {$result != {}} {
	set var(file) [file tail $result]
	set ds9(dialog,dir) [file dirname $result]
    }

    return $result
}


proc FileLast {varname fn} {
    upvar #0 $varname var

    set var(file) [file tail $fn]
}

proc FileLastFull {varname fn} {
    upvar #0 $varname var

    set var(file) [file tail $fn]
    set ds9(dialog,dir) [file dirname $fn]
}
