#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc TextDialog {frame id} {
    global marker

    set w ".marker$id"

    # see if we already have a header window visible
    if [winfo exists $w] {
	raise $w
	return
    }

    # variables
    set marker($frame,$id,canrotate) [$frame get marker $id text rotate]

    # base
    MarkerBaseCenterDialog $frame $id 375 125

    # init
    MarkerBaseCenterRotateCB $frame $id

    # callbacks
    $frame marker $id callback rotate MarkerBaseCenterRotateCB $frame

    # Angle
    label $w.ref.f.angleTitle -text [msgcat::mc {Angle}]
    entry $w.ref.f.angle -textvariable marker($frame,$id,angle) -width 13
    label $w.ref.f.angleUnit -padx 4 -text [msgcat::mc {Degrees}]

    grid $w.ref.f.angleTitle $w.ref.f.angle x $w.ref.f.angleUnit \
	-padx 4 -sticky w

    # Rotate
    label $w.ref.f.rotateTitle -text [msgcat::mc {Rotate}]
    checkbutton $w.ref.f.rotate -variable marker($frame,$id,canrotate) \
	-command "TextRotate $frame $id"
    grid $w.ref.f.rotateTitle $w.ref.f.rotate -padx 4 -sticky w
}

# actions

proc TextClose {frame id} {
    $frame marker $id delete callback rotate MarkerBaseCenterRotateCB
    MarkerBaseCenterClose $frame $id
}

proc TextApply {frame id} {
    MarkerBaseCenterRotate $frame $id
    MarkerBaseCenterApply $frame $id
}

proc TextRotate {frame id} {
    global marker
    $frame marker $id text rotate $marker($frame,$id,canrotate)
}

# callbacks

proc TextCoordCB {frame id} {
    global debug
    if {$debug(tcl,marker)} {
	puts "TextCoordCB"
    }
    MarkerBaseCoordCB $frame $id
    MarkerBaseCenterMoveCB $frame $id
    MarkerBaseCenterRotateCB $frame $id
}

